/* filestate.c
 * contains state information
 * for files.
 *
 * (c) Copyright 2000 Aaron Kimball
 */


LPFILESTATE pFirstFile;
LPFILESTATE pLastFile;
LPFILESTATE pThisFile;

LPFILESTATE create_file(LPFILESTATE lpPrev)
{
        LPFILESTATE lpBob;

        lpBob = malloc(sizeof(FILESTATE));
        if(!lpBob)
        {
                fprintf(stderr,"Out of memory.\n");
                return 0;
        }
        memset(lpBob,0,sizeof(FILESTATE));
        pLastFile = lpBob;
        if(lpPrev) lpPrev->pNextState = lpBob;
        pThisFile = lpBob;
        lpBob->pPrevState = lpPrev;
        return lpBob;
}


int kill_file(LPFILESTATE lpFS)
{

        if(pLastFile == lpFS) pLastFile = lpFS->pPrevState;
        if(pThisFile == lpFS) pThisFile = lpFS->pPrevState;

        if(lpFS->pPrevState) lpFS->pPrevState->pNextState = lpFS->pNextState;
        if(lpFS->pNextState) lpFS->pNextState->pPrevState = lpFS->pPrevState;

        free(lpFS);
        return 0;
}


int kill_all_files(LPFILESTATE lpFirst)
{
        LPFILESTATE lpCur;
        LPFILESTATE lpNext;

        lpCur = lpFirst;
        while(lpCur)
        {
                lpNext = lpCur->pNextState;
                free(lpCur);
                lpCur = lpNext;
        }
        return 0;
}
