/* funcargs.c
 *
 * allows for argument passing to user functions
 * for the emu language.
 *
 *
 * (c) Copyright 2000-2001 Aaron Kimball
 */


LPFUNCARGS pFirstFuncArg=0;
LPFUNCARGS pLastFuncArg=0;

int pop_arg_string()
{
	LPFUNCARGS pNewLast;
	pNewLast = pLastFuncArg->prev;
        return kill_arg_list_item(pLastFuncArg);
	pLastFuncArg = pNewLast;
}

int add_arg_string(char *str)
{
        //adds an LPFUNCARGS to the stack
        //returns the func_depth
        //send em the arg list.

        SAFESTRING arglist;
        SAFESTRING curexpr;
        char *p1=0,*p2=0,*p3=0,*p4=0;
        signed long i_ret;
        double d_ret;
        int offset;
	int p_off;
        int x,content;
	int is_a_str;
        char doublestr[32];
	SAFESTRING curterm;
	SAFESTRING str_eval;
	SAFESTRING str_eval_2;
	LPFUNCTIONDEF lpFunc;
	int numquotes;
	int numparens;

        create_arg_list_item();

        if(!str)
        {
                addrawstr(pLastFuncArg->argstr,"");
                return CallDepth+1;
        }
        if(!strlen(str))
        {
                addrawstr(pLastFuncArg->argstr,"");
                return CallDepth+1;
        }

        zerostring(&arglist);
        addrawstr(&arglist,str);
        zerostring(&curexpr);
        // now 'arglist' must be checked for commas;
        // finding one means we need to evaluate what comes before it.
        for(p1 = arglist.str;*p1;p1++)
        {
                if(*p1 == ' ' || *p1 == '\t' || *p1 == ',') continue;
		numquotes = 0;
		numparens = 0;
		for(p2=p1;*p2;p2++)
		{
			//find the comma, not in a string.
			if(*p2 == '\"') 
			{
				for(p3=p2-1;p3 >= p1; p3--) if(*p3 != '\\') break;
				if( (p2-p3) % 2 ) numquotes++;
			}	
			if(*p2 == ',' && !(numquotes%2) && !(numparens)) break;

			if(*p2 == '(' && !(numquotes%2)) { numparens++; p4 = p2; }
			if(*p2 == ')' && !(numquotes%2)) 
			{
				numparens--;
				if(!numparens)
				{
					//time to evaluate a block of stuff, right here.
					zerostring(&curexpr);
					addrawstrn(&curexpr,p4+1,p2-p4-1);
					offset = p4 - arglist.str;
					p_off = p1 - arglist.str;
					i_ret = d_ret = 0;
					x = eval_expression(curexpr.str,&i_ret,&i_ret,&d_ret,7,0);
					if(x == 11)
					{
						//its a string.
						zerostring(&curexpr);
						addrawstrn(&curexpr,p4+1,p2-p4-1);
                        	                zerostring(&str_eval);
                	                        do_string_eval_work(&curexpr,&str_eval);
        	                                zerostring(&str_eval_2);
	                                        addrawstr(&str_eval_2,"\"");
                                        	addsafestr(&str_eval_2,&str_eval);
                                	        addrawstr(&str_eval_2,"\"");
                        	                replacestr(&arglist,offset,p2-p4+1,str_eval_2.str);
                	                        p2 = arglist.str + offset + strlen(str_eval_2.str) - 1;
						p1 = arglist.str + p_off;
        	                                killstring(&str_eval);
	                                        killstring(&str_eval_2);
						continue;
					}
					if(x) { print_eval_error(x); pop_arg_string(); return -3; }
					//take our happy numerical response and deal with it, here.
					if(!d_ret && i_ret) d_ret = (double)i_ret; 
					memset(doublestr,0,32);
					sprintf(doublestr,"%g",d_ret);
					replacestr(&arglist,offset,p2-p4+1,doublestr);
					p2 = arglist.str + offset + strlen(doublestr);
					p1 = arglist.str + p_off;
					continue;
				}
			}

		}
                if(*p2 == 0) p2 = p1 + strlen(p1);
                if(p2)
                {
                        if(*p1 == '\"')
                        {
				zerostring(&curexpr);
				addrawstrn(&curexpr,p1,p2-p1);
				goto evaluate_string;
				if(strlen(p2) == 0) break;
                                continue;
                        }
                        zerostring(&curexpr);
                        offset = p1-arglist.str;
                        addsafestrno(&curexpr,&arglist,p2-p1,offset);
                        content=0;
                        for(p3=curexpr.str;*p3;p3++)
                        {
                                if(*p3 != ' ' && *p3 != '\t')
                                {
                                        content=1;
                                        break;
                                }
                        }
                        if(!content) break; //there's nothing worth evaluating.
			//at this point, we have an expression of some sort.
			//look for the first term. if its a string variable, then pass it to the
			//string evaluation subsystem. otherwise, dump it into eval_expression()
			//for algebra parsing.

			if(isdigit(*p3)) goto evaluate_algebra;

			is_a_str = 0;
			for(p4=p3;*p4;p4++)
			{
				if(*p4 == ' ' || *p4 == '\t') break;
			}
			zerostring(&curterm);
			addrawstrn(&curterm,p3,p4-p3);
			lpFunc = GetUserIdentifier(curterm.str);
			killstring(&curterm);
			if(lpFunc)
			{
				if(lpFunc->type == 5)
				{
evaluate_string:
					offset = p1-arglist.str;
					//its a string-based expression. evaluate it as such.
					zerostring(&str_eval);
					do_string_eval_work(&curexpr,&str_eval);
					zerostring(&str_eval_2);
					addrawstr(&str_eval_2,"\"");
					addsafestr(&str_eval_2,&str_eval);
					addrawstr(&str_eval_2,"\"");
					replacestr(&arglist,offset,p2-p1,str_eval_2.str);
					p1 = arglist.str + offset + strlen(str_eval_2.str);
					killstring(&str_eval);
					killstring(&str_eval_2);
					if(!(*p1)) break;
					continue;
				}
			}

evaluate_algebra:
                        i_ret = d_ret = 0;
                        x = eval_expression(curexpr.str,&i_ret,&i_ret,&d_ret,7,0);
                        if(x)
                        {
                                print_eval_error(x);
                                killstring(&arglist);
                                killstring(&curexpr);
				pop_arg_string();
				if(x == 10) 
				{
					force_jump = global_cur_line;
					sub_line_goto = global_cur_subline;
					return -10;
				}
                                return -1;
                        }
                        if(i_ret)
                        {
                                replacestr(&arglist,offset,p2-p1,ltoa(i_ret));
                                p1 = arglist.str + offset + strlen(ltoa(i_ret)) - 1;
                                continue;
                        }
                        else
                        {
				offset = p1 - arglist.str;
                                memset(doublestr,0,32);
                                sprintf(doublestr,"%g",d_ret);
                                replacestr(&arglist,offset,p2-p1,doublestr);
                                p1 = arglist.str + offset + strlen(doublestr) - 1;
                                continue;
                        }
                } //if there's another parameter
        } //while we check the entire arg list

        addsafestr(pLastFuncArg->argstr,&arglist);
        killstring(&arglist);
        killstring(&curexpr);

        return CallDepth+1;
}

int kill_entire_arg_stack(LPFUNCARGS lpFirst)
{
        LPFUNCARGS lpNext;
        LPFUNCARGS lpThis;
	lpThis = lpFirst;
	while(lpThis)
	{
		lpNext = lpThis->next;
                if(lpThis == 0) break;
                kill_arg_list_item(lpThis);
		lpThis = lpNext;
	}

	return 0;
}

int kill_arg_list_item(LPFUNCARGS lpss)
{
        if(lpss->prev) lpss->prev->next = lpss->next;
        if(lpss->next) lpss->next->prev = lpss->prev;
	if(pLastFuncArg == lpss) pLastFuncArg = pLastFuncArg->prev;
        killstring(lpss->argstr);
        free(lpss->argstr);
	free(lpss);
	return 0;
}


int create_arg_list_item()
{
        LPFUNCARGS lpfa;

        lpfa = malloc(sizeof(FUNCARGS));
        if(!lpfa) return 1;
        memset(lpfa,0,sizeof(FUNCARGS));

        lpfa->argstr = malloc(sizeof(SAFESTRING));
        if(!lpfa->argstr)
        {
                free(lpfa);
                return 1;
        }
        memset(lpfa->argstr,0,sizeof(SAFESTRING));
        zerostring(lpfa->argstr);

        lpfa->prev = pLastFuncArg;
        lpfa->next = 0;
        if(pLastFuncArg) pLastFuncArg->next = lpfa;
        pLastFuncArg = lpfa;

        return 0;
}


char *get_arg_string(int func_depth)
{
        LPFUNCARGS lpNext;
        int i;

        lpNext = pFirstFuncArg;
        for(i=0;i<func_depth;i++)
        {
                lpNext = lpNext->next;
                if(!lpNext) return 0;
        }


        return lpNext->argstr->str;
}

int get_next_arg(int func_depth,int *sz,char **buf,int *type)
{
        LPFUNCARGS lpNext;
        int i;
        int x;

        lpNext = pFirstFuncArg;
        for(i=0;i<func_depth;i++)
        {
                lpNext = lpNext->next;
                if(!lpNext) return 0;
        }

        x = get_arg_by_num(func_depth,lpNext->cur_arg+1,sz,buf,type);

        return x;
}


//error codes:
// 0 - success
// 1 - not enuf args to fulfill request
// 2 - invalid argument type (read: Array)
// 3 - invalid characters in argument.
SAFESTRING str_func_arg;

int get_arg_by_num(int func_depth,int arg,int *sz,char **buf,int *type)
{
        LPFUNCARGS lpNext;
        int i;
        int quotes,slashes;
        int c;
        int isdot,isneg;
        static double d_ret;
        char *p1=0,*p2=0,*p3=0;

        lpNext = pFirstFuncArg;
        for(i=0;i<func_depth;i++)
        {
                lpNext = lpNext->next;
                if(!lpNext) return 0;
        }

        p1 = lpNext->argstr->str;

        for(c = 0; c <= arg; c++)
        {
                while(*p1 == ' ' || *p1 == '\t') p1++;

                if(c == arg)
                {
                        //we have it.
                        //lets be intelligent about type here.
                        //if it starts with {, its an array.
                        //if it starts with ", its a string.
                        //all others are considered 'real'
                        switch(*p1)
                        {
                        case '{':
                                //array
                                return 2; //unsupported
                                break;
                        case '\"':
                                //string
                                //find the end of the string.
                                quotes = slashes = 0;
                                for(p3 = p1+1; *p3; p3++)
                                {
                                        if ( *p3 == '\"' )
                                        {
						for(p2 = p3-1; p2 >= lpNext->argstr->str; p2--)
							{ if(*p2 != '\\') break; }
						if((p3-p2)%2) quotes++;
                                        }
                                        if ( quotes == 1 ) { p3++; break; }
                                }
                                zerostring(&str_func_arg);
                                addrawstrn(&str_func_arg,p1,p3-p1);
                                if(sz) *sz = p3-p1;
                                if(buf) *buf = str_func_arg.str;
                                *type = 0; //string
                                lpNext->cur_arg = arg;
                                return 0;
                                break;
                        default:
                                //real, we think
                                //check for illegal characters first.
                                isdot = isneg = 0;
                                for(p2 = p1;*p2;p2++)
                                {
                                        if (*p2 == ',') break;
                                        if (*p2 == '.')
                                        {
                                                if(isdot) return 3;
                                                isdot = 1;
                                                continue;
                                        }
                                        if (*p2 == '-')
                                        {
                                                if(isneg) return 3;
                                                if(isdot) return 3;
                                                isneg = 1;
                                                continue;
                                        }
                                        if (isdigit(*p2)) continue;
                                        return 3;
                                }
                                if( *p1 != '-' && *p1 != '.' && !isdigit(*p1))
                                        return 3;

                                //get the float data, mark its location,
                                //set size of data buf, and go home.
                                d_ret = atof(p1);
                                global_double_return = d_ret;
                                if(buf) *buf = 0;
                                if(sz) *sz = sizeof(double);
                                *type = 1; //number
                                lpNext->cur_arg = arg;
                                return 0;
                                break;
                        }
                }  //if c == arg

                quotes = 0;
                for( ; *p1; p1++)
                {
                        if ( *p1 == '\"' )
                        {
                                //check if its escaped.
                                for(p2 = p1-1; p2 >= lpNext->argstr->str ; p2--)
                                	{ if(*p2 != '\\') break; }
				if((p2-p1)%2) quotes++;
                        }
                        //if we find a comma, then we've found next term.
                        if ( *p1 == ',' && !(quotes % 2)) { p1++; break; }
                }

                if(!(*p1)) return 1; //out of string prematurely.
        } //loop thru all args.

        return 0;        
        
}


int get_arg_count(int func_depth,int *buf)
{
        LPFUNCARGS lpNext;
        int i;
        int quotes=0,slashes=0;
        int count=0;
        int is_in = 0;
        char *p1=0,*p2=0;

        lpNext = pFirstFuncArg;
        for(i=0;i<func_depth;i++)
        {
                lpNext = lpNext->next;
                if(!lpNext) return 1;
        }

        
        for(p1 = lpNext->argstr->str;*p1;p1++)
        {
                if(*p1 == ',' && !(quotes%2) && is_in)
                {
                        quotes=0;
                        is_in = 0;
                        continue;
                }

                if(*p1 == '\"')
                {
                        slashes = 0;
                        for(p2 = p1-1;p2 > lpNext->argstr->str-1;p2--)
                        {
                                if(*p2 != '\\') break;
                                slashes++;
                        }
                        if(!(slashes%2)) quotes++;
                }

                if(*p1 == ' ' || *p1 == '\t') continue;
                if(!is_in) count++;
                is_in = 1;
        } //loop thru all args.

        *buf = count;

        return 0;
}


int GetStringArg (char *str, LPSAFESTRING safestr)
{

        char *p1=0,*p2=0;
        char *n1=0;
        int numslashes;
	LPFUNCTIONDEF lpFunc;
	

        for(p1=str;*p1;p1++)
        {
                if(*p1 == ' ' || *p1 == '\t') continue;
                if(*p1 == '\"') break;
		if(*p1 == '_' || isalpha(*p1)) 
		{
			break;
		}
                return 1; //invalid ident.
        }
	if(!(*p1)) //no parameter. balk.
	{
		return 2; //str expected.
	}
        if(*p1 != '\"') //no quotes. assume, therefore, that it is a string variable. 
        {
		for(p2=str;*p2;p2++) if(isalpha(*p2) || *p2 == '_') break;
		if(!(*p2))
		{
			//nothing that looks like an identifier. 
			return 4;
		}
		for(p1=p2;*p1;p1++) if(!isalnum(*p1) && *p1 != '_') break;
		zerostring(safestr);
		addrawstrn(safestr,p2,p1-p2);
		lpFunc = GetUserIdentifier(safestr->str);
		killstring(safestr);
		if(!lpFunc)
		{
			return 3; //identifier expected.
		}
		if(lpFunc->type != 5) 
		{
			//this isn't a string. we need a string.
			return 4;
		}	

		//get the result.
		zerostring(safestr);
		addsafestr(safestr,lpFunc->val.str_val);
		return 0;
        }

        p1++;
        for(p2 = p1;*p2;p2++)
        {
                if(*p2 == '\"')
                {
                        numslashes=0;
                        for(n1 = p2-1; n1 > p1-1;n1--)
                        {
                                if(*n1 == '\\') numslashes++;
                                else break;
                        }
                        if(numslashes%2) continue;

                        //we've found it.
                        zerostring(safestr);
                        addrawstrn(safestr,p1,p2-p1);
			return 0;
		}
	}

	return 0;
}


int GetLongArg (char *str, long *retval)
{

	//our entire arg string is one number.
	//therefore, evaluate it as such.
	if(!str) return 5; //identifier expected. (null pointer)
	return eval_expression(str,retval,retval,0,3,0);
}

