/* interp.c
 * Emu Programming Language Interpretter
 * 
 * actually interprets the commands passed to it
 * from get_one_statement
 *
 * (c) Copyright 2000 Aaron Kimball
 *
 */

#include<stdio.h>
#include<string.h>
#include<memory.h>

int ExecFunc = -1;
int bSeeking = 0; //1 = function, 2 = endif, 3 = else/elseif/endif, 4 = finding label
		//5 = for/while loop searching for 'loop
SAFESTRING seekstr;
int seekline;
int userseekline;
int CallDepth = 0;
int IfDepth = 0;
int CurIfEvaluation;
int LoopsEncountered = 0;
int sub_line_goto;
long force_jump;
FILE *fpout_global;

//#define LINE_PRINTING

//god is this gonna become spaghetti code quickly.
//
//(update 9.13.2000: yup, it did. --ak)

//returns the next statement to exec or -1 if it should read a new one.
long interpret_command(long cmd,LPSAFELISTITEM pThisLine,FILE *fpin,FILE *fpout)
{
        char *p1=0,*p2=0;
        SAFESTRING funcname; //the function we're calling.
	SAFESTRING curline;
	LPFUNCTIONDEF lpNextFunc;
        long int n,i,x=0;
	double dret;
        int has_equal = 0;
	char opchars[] =   "+-/*^|&";
	char has_op;
	char *replaceline;
	int numbrackets;

//print out cur statement.
#ifdef LINE_PRINTING
printf("[%i %i %i %i %i %i %i] [<%ld.%ld>][<%ld>] [[%s]]\n",ExecFunc,bSeeking,CallDepth,bInFunc,pThisLine->type,IfDepth,CurIfEvaluation,pThisLine->line_no,pThisLine->sub_line_no,pThisLine->user_line_no,pThisLine->str);
#endif /* LINE_PRINTING */

	fpout_global = fpout;

	sub_line_goto = 0;
	force_jump = -1; 

        zerostring(&funcname);
        global_cur_line = pThisLine->line_no;
	global_cur_subline = pThisLine->sub_line_no;
	global_cur_user_line = pThisLine->user_line_no;

        if(bSeeking == 1) //seeking for a function
        {
                //NOTE:
                //we hafta scan the top of the call stack for any -2's
                //in line-to-return-to. if one exists, patch it to
                //pThisLine->line_no (since this is where the EOF was.)
                for(x = 0; x < STACK_MAX; x += 3)
	  	   if(calls.data[x] == 0 && calls.data[x+2] == -2) calls.data[x+2] = pThisLine->line_no;

                //we're searching for a function.
                //that means we only honor three statements:
                //"include", "func", and "return".
                //anything else is ignored.
                //those three should be ran normally.
                for(p1 = pThisLine->str;*p1;p1++)
                {
                        if(*p1 == ' ' || *p1 == '\t') continue;
                        break;
                }
                if(!(*p1)) goto after_exec;
                if(strncmp(p1,"include ",8)==0 ||
                   strncmp(p1,"include\t",8)==0 ||
                   strncmp(p1,"func ",5)==0 ||
                   strncmp(p1,"func\t",5)==0 ||
                   strncmp(p1,"return ",7)==0 ||
		   strncmp(p1,"return\t",7)==0 ||
		   strncmp(p1,"return\n",7)==0)
                {
        		force_jump = tiny_func_run(p1,fpin,fpout,pThisLine);
	        } //if its one of the honored functions.

                goto after_exec;
        }

	if(bSeeking == 2)
	{
		//only searching for an ENDIF, but also value IF and RETURN
                for(p1 = pThisLine->str;*p1;p1++)
                {
                        if(*p1 == ' ' || *p1 == '\t') continue;
                        break;
                }
                if(!(*p1)) goto after_exec;
                if(strncmp(p1,"include ",8)==0 ||
                   strncmp(p1,"include\t",8)==0 ||
                   !strncmp(p1,"if ",3) ||
                   !strncmp(p1,"if\t",3)||
                   !strncmp(p1,"endif ",6) ||
                   !strncmp(p1,"endif\0",6) ||
                   !strncmp(p1,"endif\t",6) ||
                   !strncmp(p1,"return ",7) ||
                   !strncmp(p1,"return\t",7) ||
                   !strncmp(p1,"return\0",7))
                {
                        //do something
                        force_jump = tiny_func_run(p1,fpin,fpout,pThisLine);
                }

                goto after_exec;

	}

	if(bSeeking == 3)
	{
		//we're inside an if/then thingy
		//we only honor IF, ELSE, ELSEIF and ENDIF, and RETURN
                for(p1 = pThisLine->str;*p1;p1++)
                {
                        if(*p1 == ' ' || *p1 == '\t') continue;
                        break;
                }
                if(!(*p1)) goto after_exec;
                if(strncmp(p1,"include ",8)==0 ||
                   strncmp(p1,"include\t",8)==0 ||
		   !strncmp(p1,"else ",5) ||
		   !strncmp(p1,"else\0",5) ||
		   !strncmp(p1,"else\t",5) ||
		   !strncmp(p1,"if ",3) ||
		   !strncmp(p1,"if\t",3)||
		   !strncmp(p1,"elseif ",7) ||
		   !strncmp(p1,"elseif\0",7) ||
		   !strncmp(p1,"elseif\t",7) ||
		   !strncmp(p1,"endif ",6) ||
		   !strncmp(p1,"endif\0",6) ||
		   !strncmp(p1,"endif\t",6) ||
		   !strncmp(p1,"return ",7) ||
		   !strncmp(p1,"return\t",7) ||
		   !strncmp(p1,"return\0",7))
		{
			//do something
			force_jump = tiny_func_run(p1,fpin,fpout,pThisLine);
		}

		goto after_exec;
	}

	if(bSeeking == 4)
	{
		//we hit a goto, and didn't find the label. we're searching lower in 
		//the file for it. 
		//we honor FUNC, RETURN, and LABEL.
                for(p1 = pThisLine->str;*p1;p1++)
                {
                        if(*p1 == ' ' || *p1 == '\t') continue;
                        break;
                }
                if(!(*p1)) goto after_exec;
                if(strncmp(p1,"include ",8)==0 ||
                   strncmp(p1,"include\t",8)==0)
		{
			force_jump = tiny_func_run(p1,fpin,fpout,pThisLine);
		}

                if(!strncmp(p1,"func ",5) ||
                   !strncmp(p1,"func\0",5) ||
                   !strncmp(p1,"func\t",5))
		{
                        force_jump = tiny_func_run(p1,fpin,fpout,pThisLine);
			CallDepth++;
                }
 		
                if(!strncmp(p1,"return ",7) ||
                   !strncmp(p1,"return\t",7) ||
                   !strncmp(p1,"return\0",7))
                {
			if(labeldepth > 0) 
			{
				//hey, the function ended. the label ain't there.
				SysErr("Label not found in function.");
				//go back.
				bSeeking = 0;
				force_jump = seekline + 1;
			}
			else
			{
	                        force_jump = tiny_func_run(p1,fpin,fpout,pThisLine);
				CallDepth--;
			}
                }
                if(!strncmp(p1,"label ",6) ||
                   !strncmp(p1,"label\0",6) ||
                   !strncmp(p1,"label\t",6))
		{
			if(labeldepth == CallDepth)
				force_jump = tiny_func_run(p1,fpin,fpout,pThisLine);
		}

                goto after_exec;

	}
	
	if(bSeeking == 5)
	{
		//We're resolving a for loop.
		//If we find a 'loop' keyword, and LoopsEncountered == 0,
		//then we've found what we're looking for. Seek over, execute.

		//if we find a nested for, (or while), then LoopsEncountered++.
		//if we find a 'loop', loopsencountered--;

		//if loopsencountered == 0, and we hit a continue, then execute it.
		//(continue actually just degerenates into 'goto %cont_xx')

		//a function causes a fatal error.
                for(p1 = pThisLine->str;*p1;p1++)
                {
                        if(*p1 == ' ' || *p1 == '\t') continue;
                        break;
                }
                if(!(*p1)) goto after_exec;

		if(strncmp(p1,"include ",8)==0 ||
                   strncmp(p1,"include\t",8)==0)
                {
                        force_jump = tiny_func_run(p1,fpin,fpout,pThisLine);
			goto after_exec;
                }

		if((strncmp(p1,"continue ",9)==0) ||
		   (strncmp(p1,"continue\t",9)==0) ||
		   (strncmp(p1,"continue\0",9)==0))
		{
			//we've found a continue. does it have the right param?
			if(LoopsEncountered == 0)
			{
				//no loops encountered; automatically go for it.
        	                force_jump = tiny_func_run(p1,fpin,fpout,pThisLine);
				goto after_exec;
			}
			for(p2=p1+9;*p2;p2++)
			{
				//determine if there's a param.
				if(*p2 != ' ' && *p2 != '\t') break; //yea
			}
			if(strlen(p2))
			{
				//there's something -- lets run with it.
				n = eval_expression(p2,&i,&i,&dret,4,-2);
				print_eval_error(n);
				if(n == 11) SysErr("Argument is a string.\n");
				if(n) goto after_exec;
				if(!i && dret) i = (long)dret;
				if(i-1 == LoopsEncountered)
				{
					force_jump = tiny_func_run(p1,fpin,fpout,pThisLine);
				}
			}
			goto after_exec;
		}

		if(!strncmp(p1,"for ",4) ||
		   !strncmp(p1,"for\t",4) ||
		   !strncmp(p1,"while ",6) ||
		   !strncmp(p1,"while\t",6))
		{
			LoopsEncountered++;
			goto after_exec;
		}

		if(!strncmp(p1,"func ",5) ||
		   !strncmp(p1,"func\t",5) ||
		   !strncmp(p1,"func\n",5))
		{
			SysErr("Functions can not be nested in loops");
			bSeeking = 0;
			force_jump = seekline;
			goto after_exec;	
		}

		if(!strncmp(p1,"return ",7) ||
		   !strncmp(p1,"return\t",7) ||
		   !strncmp(p1,"return\n",7) ||
		   !strncmp(p1,"return\0",7))
		{
			SysErr("Unterminated loop");
			bSeeking = 0;
			force_jump = seekline;
			goto after_exec;
		}

		if(!strncmp(p1,"loop ",5) ||
		   !strncmp(p1,"loop\n",5) ||
		   !strncmp(p1,"loop\t",5) ||
		   !strncmp(p1,"loop\0",5))
		{
			if(LoopsEncountered) 
			{ 
				LoopsEncountered--; 
				goto after_exec; 
			}
			else
			{
				bSeeking = 0;
				goto exec_system;
			}
		}

		goto after_exec;
	}

	if(bSeeking == 6)
	{
		//we've hit a break, and are searching for our escape point.
                for(p1 = pThisLine->str;*p1;p1++)
                {
                        if(*p1 == ' ' || *p1 == '\t') continue;
                        break;
                }
                if(!(*p1)) goto after_exec;

                if(strncmp(p1,"include ",8)==0 ||
                   strncmp(p1,"include\t",8)==0)
                {
                        force_jump = tiny_func_run(p1,fpin,fpout,pThisLine);
                        goto after_exec;
                }

		if(strncmp(p1,"goto %break_",12)==0 ||
		   strncmp(p1,"for ",4)==0 ||
		   strncmp(p1,"for\t",4)==0 ||
		   strncmp(p1,"for\n",4)==0 ||
		   strncmp(p1,"while ",6)==0 ||
		   strncmp(p1,"while\t",6)==0 ||
		   strncmp(p1,"while\n",6)==0)
		{
			LoopsEncountered++;
		}

		if(strncmp(p1,"label %break_",13)==0)
		{
			LoopsEncountered--;
			if(LoopsEncountered == 0)
			{
				bSeeking = 0;
				find_label(p1+6,&force_jump,pThisLine); //set up our jump and stack.	
			}
		}

		goto after_exec;
	}

        if(bInFunc == 1)
        {
                //we're in a function which we're not supposed to execute.
                //if the current line is 'return' then turn everything
                //back on.
                //otherwise, go to next line.
                if(strncmp(pThisLine->str,"return",6)==0)
                {
			p1 = pThisLine->str+6;
			switch(*p1)
			{
			case '\n':
			case '\t':
			case  ' ':
			case 0   :
 	                        lpNextFunc = GetUserIdentifier("return");
				lpNextFunc->ptr.func(p2,fpin,fpout,pThisLine,&force_jump);
			default:
				goto after_exec;
			}
                }

                goto after_exec;
        }

exec_system:

        if(!pThisLine->type > 0 && bCopying)
	{
		//it's text. copy it..
                fprintf(fpout,"%s",pThisLine->str);
		fflush(fpout); 
	}

        if(pThisLine->type > 0)
	{

		//execute it normally

                //first, get the name of the function/lvalue separate from the args.
		zerostring(&curline);
                addrawstr(&curline,pThisLine->str);
                p1 = strtok(curline.str," \t="); //put a str-end @ a whitespace
                p2 = strtok(NULL,""); //and then isolate the real end
		n = strlen(curline.str);

                if(n > 40)
                {
                        SysErr("Identifier too long");
                        goto after_exec;
                }

                addsafestr(&funcname,&curline);


                //check for an equal-sign in there
		has_op = 0;
		numbrackets = 0;
                for(p1 = pThisLine->str; *p1 != 0; p1++)
                {
			if ( *p1 == '[') { numbrackets++; continue; }
			if ( *p1 == ']') { numbrackets--; continue; }
                        if ( *p1 == '=') { x = 1; break; }
                        if ( *p1 == ' ' || *p1 == '\t') continue;
			if (!numbrackets)
			{
				for(i=0;i<strlen(opchars);i++)
				{
					if(*p1 == opchars[i]) 
					{
						has_op = opchars[i];
						if(*(p1+1) == '=') x = 1;
						goto done_equals_check;
						break;
					}
				}
			}
                }

done_equals_check:

                if(x && p1 > pThisLine->str) has_equal = 1;
		if(has_op && has_equal)
		{
			//we have to unfold n += x --> n = n + (x)
			for(p1=p1+2;*p1;p1++)
				if(*p1 != ' ' && *p1 != '\t') break;
			if(strlen(p1) == 0)
				{ SysErr("Expected: expression."); return 0; }
			if(strlen(funcname.str) == 0) 
				{ SysErr("Function call missing."); return 0; }
			replaceline = malloc(strlen(pThisLine->str) + 50);
			if(!replaceline)
			{
				SysErr("Out of memory.");
				return 0;
			}	
			sprintf(replaceline,"%s = %s %c (%s)",funcname.str,funcname.str,has_op,p1);
			update_list_item(pThisLine,replaceline);
			free(replaceline);
			p2 = pThisLine->str + strlen(funcname.str)+1;
		}

                if(!strlen(funcname.str))
			{ SysErr("Function call missing."); }
		else
		{
                        //we found a function name. now do something with it.
                        lpNextFunc = GetUserIdentifier(funcname.str);

                        if(lpNextFunc)
			{
				//ok, we have the function we need. jump to it!
				switch(lpNextFunc->type)
				{
				case 1:
					//user defined function

                                        //send em the arg list.
                                        if(add_arg_string(p2) < 0)
					{
						SysErr("Argument list invalid.\n");
						break; // don't carry thru with the function call.
					}

                                        force_jump = lpNextFunc->ptr.line; //jump to it.
					if(push(&calls,0) == -2)
					{
						SysErr("Too many function calls.");
						goto after_exec;
					}
                                        if(push(&calls,ExecFunc) == -2)
                                        {
                                                SysErr("Too many function calls.");
                                                goto after_exec;
                                        }
                                        if(pThisLine->next)
                                        {
                                                if(push(&calls,pThisLine->next->line_no) == -2)
                                                {
                                                        SysErr("Too many function calls.");
                                                        goto after_exec;
                                                }
						push(&calls,pThisLine->next->sub_line_no);
                                        }
                                        else
                                        {
                                                if(push(&calls,-2) == -2) //go to EOF on return
                                                {
                                                        SysErr("Too many function calls.");
                                                        goto after_exec;
                                                }
						push(&calls,0);
                                        }
					push(&calls,IfDepth);
                                        ExecFunc = lpNextFunc->ptr.line;
					//i think i need this, but not sure:
					IfDepth = 0;

                                        break;
                                default:
                                        //intrinsic function, keyword, or variable
                                        if(lpNextFunc->type > 1 && !has_equal && lpNextFunc->type != 13)
                                        {
                                                //this line is only an rvalue
                                                SysWarn("Result of expression is not used.");
                                        }
					if(!lpNextFunc->ptr.func)
					{
						SysErr("Identifier is constant.");
					}
					else { lpNextFunc->ptr.func(p2,fpin,fpout,pThisLine,&force_jump); }
					break;
				} //switch on function type
			} //if we found the function
			else
			{
                                //ok. the function doesn't exist. that is, we dont know if it exists.
                                //it could appear lower down in the file. therefore, we gotta seek
                                //forwards to the end to find it.
				push(&calls,0);
                                push(&calls,ExecFunc);
                                push(&calls,pThisLine->line_no); //save our position
				push(&calls,pThisLine->sub_line_no);
				push(&calls,IfDepth);
                                seekline = pThisLine->line_no;
				userseekline = pThisLine->user_line_no;
                                zerostring(&seekstr);
                                addsafestr(&seekstr,&funcname); //record what we're lookin for.
                                bSeeking = 1; //switch into seek mode.
                                force_jump = -2; //force starting at EOF
                                ExecFunc = -1;
				//i think i need this, but not sure:
				IfDepth=0;
			} //if function not found
		} //if we're in a theoretically legal function call.
	}

after_exec:

        //execution of the statement's done! the question is, which statement
        //comes next? :)
        if(!pThisLine)
        {
                next_statement++;
                next_to_exec = -1;
        }
        else
        {
                if(!pThisLine->next) 
                {
                        //we're on the last item, and we didn't have a flow break...
                        next_statement++; //inc the number of the next to add...
                        next_to_exec = -1; //and execute a new line.
                }                 
                else
                {
                        //we're in the middle of the program, go to the next line
                        next_to_exec = pThisLine->next->line_no; 
			if(force_jump == -1) sub_line_goto = pThisLine->next->sub_line_no;
                }
        }

        //Old MacDonald had a farm...
        //EIEIO! (?) (Enforce in-order execution of IO)
        if(force_jump != -1) next_to_exec = force_jump; //nope! :)
        if(force_jump == -2)
        {
                //force a jump to EOF even if we're in the middle of the file.
                next_statement++;
                next_to_exec = -1;
        }

        killstring(&funcname);

	return next_to_exec;
}



long tiny_func_run(char *p1,FILE* fpin,FILE* fpout,LPSAFELISTITEM pThisLine)
{
	long force_jump = -1;
        char *p2=0,*p3 = 0;
        SAFESTRING curline;
	LPFUNCTIONDEF lpNextFunc;

	//it's good.
/*
        //well, actually, if its a return, you gotta check..
        if(strncmp(p1,"return",6)==0)
        {
        	for(p2 = p1 + 6; *p2; p2++)
                {
	                if(*p2 == ' ' || *p2 == '\t') continue;
                        if(*p2) return force_jump;
                }
        } //whitespace test on return
*/
        //set p2 to point to params.
        p2 = strchr(p1,' ');
        p3 = strchr(p1,'\t');
        if(!p2) p2 = p3;
	if(!p2) { p2=strchr(p1,0); }

        zerostring(&curline);
        addrawstrn(&curline,p1,p2-p1);
        lpNextFunc = GetUserIdentifier(curline.str);
        killstring(&curline);
	if(lpNextFunc->ptr.func)
		{ lpNextFunc->ptr.func(p2,fpin,fpout,pThisLine,&force_jump); }
	else
		{ SysErr("Identifier is constant."); }

        //we've ran it.
        //now test if our func exists.
        if(GetUserIdentifier(seekstr.str) && bSeeking == 1)
        {
                //yes! reset to state before seek!
                bSeeking = 0;
                bInFunc = 0;
		IfDepth = pop(&calls);
		sub_line_goto = pop(&calls);
                force_jump = pop(&calls);
                ExecFunc = pop(&calls);
		pop(&calls); //kill the zero
	}  

	return force_jump;
	
}
