/* uservars.c
 * contains stuff dealing with user variables...
 *
 * (c) Copyright 2000 Aaron Kimball
 */

double global_double_return;

LPFUNCTIONDEF GetUserIdentifier(char *str)
{
        unsigned long funchash;
        LPFUNCTIONDEF lpNextFunc;
        LPFUNCTIONDEF lpParentFunc;
	LPFUNCTIONDEF lpDomFunc;
        char *p1;
        int argnum;
        int bufsz,x,type;
        char *bufptr;
        char varname[41];
        char *p3=0,*p4=0;
	char *p2=0;
        SAFESTRING funcname;
        long arraynum;
        SAFESTRING tempstr;

        if(str[0] == '$')
        {
                //it's a metavariable. hold up folks
                lpNextFunc = 0;
                switch(str[1])
                {
                case '.':
                        //get next
                        x=get_next_arg(CallDepth,&bufsz,&bufptr,&type);
                        if(x)
                        {
                                //errors..
                                return 0;
                        }

                        //find the arg we're puttin this in.
                        funchash = strhash("%arg"); //pseudovar.
                        lpNextFunc = pFirstFunc;
                        while(lpNextFunc)
                        {
                                if(lpNextFunc->hash == funchash) break;
                                lpNextFunc = lpNextFunc->next;                   
                        } //while we have vars to check for the hash

                        switch(type)
                        {
                        case 0:
                                //string
                                if(lpNextFunc->type != 5)
                                {
                                        lpNextFunc->type = 5;
                                        lpNextFunc->val.str_val = malloc(sizeof(SAFESTRING));
                                }
                                zerostring(lpNextFunc->val.str_val);
                                addrawstr(lpNextFunc->val.str_val,bufptr);
                                break;
                        case 1:
                                //number
                                if(lpNextFunc->type == 5)
                                        killstring(lpNextFunc->val.str_val);
                                lpNextFunc->type = 2;
                                lpNextFunc->val.float_val = global_double_return;
                                break;
                        }
                        break;
                case '*':
                        //get as string
                        //find the arg we're puttin this in.
                        funchash = strhash("%arg"); //pseudovar.
                        lpNextFunc = pFirstFunc;
                        while(lpNextFunc)
                        {
                                if(lpNextFunc->hash == funchash) break;
                                lpNextFunc = lpNextFunc->next;                   
                        } //while we have vars to check for the hash
                        if(lpNextFunc->type != 5)
                        {
                                lpNextFunc->type = 5;
                                lpNextFunc->val.str_val = malloc(sizeof(SAFESTRING));
                        }
                        zerostring(lpNextFunc->val.str_val);
                        addrawstr(lpNextFunc->val.str_val,"\"");
                        addrawstr(lpNextFunc->val.str_val,get_arg_string(CallDepth));
                        addrawstr(lpNextFunc->val.str_val,"\"");
                        break;
                case '@':
                        //get as real array
			SysErr("This variable is not implemented.");
                        break;
                case '#':
                        //get argc
                        x = get_arg_count(CallDepth,&argnum);
                        if(x) return 0;

                        //find the arg we're puttin this in.
                        funchash = strhash("%arg"); //pseudovar.
                        lpNextFunc = pFirstFunc;
                        while(lpNextFunc)
                        {
                                if(lpNextFunc->hash == funchash) 
					if(strcmp(lpNextFunc->name,"%arg")==0) break;
                                lpNextFunc = lpNextFunc->next;                   
                        } //while we have vars to check for the hash

                        if(lpNextFunc->type == 5)
			{
                                killstring(lpNextFunc->val.str_val);
				free(lpNextFunc->val.str_val);
			}

                        lpNextFunc->type = 3;
                        lpNextFunc->val.long_val = argnum;
                        break;
                default:
                        //get as num or illegal
                        if(!isdigit(str[1])) return 0;
                        argnum = atoi(str + 1);
                        x=get_arg_by_num(CallDepth,argnum,&bufsz,&bufptr,&type);
                        if(x)
                        {
                                //errors..
                                return 0;
                        }

                        //find the arg we're puttin this in.
                        funchash = strhash("%arg"); //pseudovar.
                        lpNextFunc = pFirstFunc;
                        while(lpNextFunc)
                        {
                                if(lpNextFunc->hash == funchash) break;
                                lpNextFunc = lpNextFunc->next;                   
                        } //while we have vars to check for the hash

                        switch(type)
                        {
                        case 0:
                                //string
                                if(lpNextFunc->type != 5)
                                {
                                        lpNextFunc->type = 5;
                                        lpNextFunc->val.str_val = malloc(sizeof(SAFESTRING));
                                }
                                zerostring(lpNextFunc->val.str_val);
                                addrawstr(lpNextFunc->val.str_val,bufptr);
                                break;
                        case 1:
                                //number
                                if(lpNextFunc->type == 5)
                                        killstring(lpNextFunc->val.str_val);
                                lpNextFunc->type = 2;
                                lpNextFunc->val.float_val = global_double_return;
                                break;
                        }
                } //what to do with it?
                return lpNextFunc;
        } //if metavariable

        zerostring(&funcname);
        addrawstr(&funcname,str);

        p3=0;
        p3=strchr(funcname.str,'[');
        if(p3)
        {
                //it's an array item
                //evaluate the contents inside the array to reduce them
                //to lowest terms.
                p3++;
                p4 = strchr(p3,']');
                if(p4) //find the end.
                {
			do { p2 = strchr(p4+1,']'); if(p2) p4=p2; } while (p2);
                        if(p4 == p3)
                        {
                                SysErr("Blank array subscript.");
                                killstring(&funcname);
                                return 0;
                        }
                        //we found the end.
                        zerostring(&tempstr);
                        addrawstrn(&tempstr,p3,p4-p3);
                        x=eval_expression(tempstr.str,&arraynum,&arraynum,0,6,0);
                        killstring(&tempstr);
                        if(x)
                        {
                                print_eval_error(x);
                                SysErr("Error in array subscript.");
                                killstring(&funcname);
                                return 0;
                        }
                        if(arraynum < 0)
                        {
                                SysErr("Array subscript out of bounds.");
                                killstring(&funcname);
                                return 0;
                        }
                        replacestr(&funcname,p3-funcname.str,p4-p3,ltoa(arraynum));
                }
                else
                {
                        //there's no terminating ']'
                        SysErr("Unterminated array subscript.");
                        killstring(&funcname);
                        return 0;
                }

        }



        funchash = strhash(funcname.str); //get the hash of it.
        //now search for the damn thing.
        lpNextFunc = pFirstFunc;
	lpDomFunc = 0;

        while(lpNextFunc)
        {
                if(lpNextFunc->hash == funchash) 
                {
			if(strncmp(lpNextFunc->name,funcname.str,40) != 0)
			{
				lpNextFunc = lpNextFunc->next;
				continue; //names don't match!
			}
			if(lpNextFunc->type == 0) 
			{
				//its intrinsic. return immediately
				killstring(&funcname);
				return lpNextFunc;
			}
			if(lpNextFunc->domain == 0)
			{
				//we found a global. save it, but keep searching for a local.
				lpDomFunc = lpNextFunc;
			}
			else
			{
				if(lpNextFunc->domain == CallDepth)
				{						
	        	        	//return most specific variable. 
				        killstring(&funcname);
		                        return lpNextFunc;
				}
			}
                }
                lpNextFunc = lpNextFunc->next;                   
        } //while we have vars to check for the hash

	if(lpDomFunc)
	{
		//we found a global, but no local.
		killstring(&funcname);
		return lpDomFunc;
	}

        if(!lpNextFunc)
        {
                //we can't find it!
                //is it an array value? look for the array...
                p1 = strchr(funcname.str,'[');
                if(p1)
                {
                        memset(varname,0,41);
                        strncpy(varname,funcname.str,p1-funcname.str);
                        funchash = strhash(varname);
                        lpNextFunc = pFirstFunc;
                        while(lpNextFunc)
                        {
                                if(lpNextFunc->hash == funchash && lpNextFunc->type > 7 && lpNextFunc->type < 12)
                                {
                                        //ok, the parent exists!
                                        lpParentFunc = lpNextFunc;
                                        //create this one, init it to zero.
                                        create_intrinsic_function(funcname.str,__user_eval_expression);
                                        pLastFunc->type = lpParentFunc->type-6;
                                        pLastFunc->domain = lpParentFunc->domain;
                                        pLastFunc->parent = lpParentFunc;
                                        pLastFunc->val.float_val = 0;
					memset(pLastFunc->name,0,41);
					strncpy(pLastFunc->name,funcname.str,40);

                                        if(lpParentFunc->children < atoi(p1+1))
                                        {
                                                lpParentFunc->children = atoi(p1+1);
                                        }
                                        return pLastFunc;
                                } //if the parent exists.
                                lpNextFunc = lpNextFunc->next;
                        } //while we have vars to check
                } //if searched for target is an array slice
        } //if we couldn't find the target.

        killstring(&funcname);

        return 0;
}

int InsertFunctionCall(char *p1,char *p2,int type)
{
	LPSAFELISTITEM pNewLine1;
	LPSAFELISTITEM pNewLine2;
	LPSAFELISTITEM pNewLine3;
	int i;
	char resstr[32];
	LPFUNCTIONDEF lpVar;
	SAFESTRING quotedstr;
	SAFESTRING dummyexpr;
	SAFESTRING initialexpr;
	char *p3=0,*p4=0,*p5=0;
	char *p6=0;
	int numquotes;
	int numparens;
	int padding;

	//to execute functions in-place would actually be pretty complicated.
	//so. we're gonna hack around that (Yay!)
	//step 1.: Triplicate the current line.
	//step 2.: isolate the function call. the first of the three lines is set to only this call.
	//step 3.: create a local identifier __ret_n, where 'n' is a steadily increasing unique num.
	//step 4.: the second of these three lines is set to: __ret_n = ret;
	//step 5.: rewrite the expression to insert %ret_n over this function-call.
	//step 6.: set the global force_jump to re-jump to this line-set.

	zerostring(&dummyexpr);
	zerostring(&initialexpr);

	addrawstr(&initialexpr,p1);

	//1:
	pNewLine2 = dup_list_item(global_cur_line, global_cur_subline);
	pNewLine3 = dup_list_item(global_cur_line, global_cur_subline+1);
	pNewLine1 = pNewLine2->prev;

	//2:
	update_list_item(pNewLine1,p1);

	//3:
	for(i=0;1;i++)
	{
		memset(resstr,0,32);
		sprintf(resstr,"__ret_%i",i);
		lpVar = GetUserIdentifier(resstr);
		if(lpVar) continue;
		if(type == 2) 
		{
			lpVar = create_intrinsic_function(resstr,__user_eval_expression);
			lpVar->type = 2; //float
		}
		if(type == 5)
		{
			lpVar = create_intrinsic_function(resstr,__user_eval_string);
			lpVar->val.str_val = malloc(sizeof(SAFESTRING));
			zerostring(lpVar->val.str_val);
			lpVar->type = 5; //string
		}
		lpVar->domain = CallDepth;
		break;
	}

	//4:
	zerostring(&quotedstr);
	addrawstr(&quotedstr,resstr);
	addrawstr(&quotedstr," = ret");
	update_list_item_from_safe_str(pNewLine2,&quotedstr);
	killstring(&quotedstr);
	
	//5: //replace the expression with the __ret_n 
		//take care, however, that you don't replace something 
		//inside a string on the same line!
		//so after we find p2, we hafta check to make sure its not in a string.
		//if it is, seek forwards, again.
	p3 = pNewLine3->str;

set_p2_for_replacement:
	p6 = p2;
	p2 = strstr(p3,p1);
	p4 = p1;
	if(!p2)
	{
		//uhoh! the function call received some sort of processing
		//prior to being sent here, therefore, we can't find an exact match.
		//thus, isolate each call to the current function in the line (p3),
		//and run it thru eval_expression() with a has_op of -3. 
		//with this value, it'll bomb with special error 14 when it hits a call to this
		//function, and str_func_arg will contain the processed line. if its a match,
		//then score!

		p4 = pNewLine3->str;
		while(p4)
		{
			zerostring(&dummyexpr);
			addrawstrn(&dummyexpr,p1,p6-p1);

			p4 = strstr(p4,dummyexpr.str);
			if(!p4) break; //cant find it.

			//p4 points to a part of the string where we called the function.
			//now we must check to make sure that this point is not inside a string.
			numquotes = 0; 
			for(p3=pNewLine3->str;p3 < p4;p3++)
			{
				if(*p3 == '\"') for(p5 = p3-1; p5 >= pNewLine3->str; p5--) if(*p5 != '\\') break;
				if((p3-p5)%2) numquotes++;
			}
			if(numquotes%2) { p4++; continue;} //was inside a string.

			//p4 points to the start of a function call.
			//we now need to find the end of it. either end of line, or a closing paren.
			numparens = 0;
			numquotes = 0;
			for(p3 = p4; *p3; p3++)
			{
				if(*p3 == '\"')
				{
					for( p5 = p3-1 ;p5 >= p4; p5--) if(*p5 != '\\') break;
					if((p3-p5)%2) numquotes++;
				}
				if(*p3 == '(' && !(numquotes%2)) numparens++;
				if(*p3 == ')' && !(numquotes%2)) 
				{
					numparens--;
					if(numparens == -1) break; //we've found the end!
				}
			}

			zerostring(&dummyexpr);
			addrawstrn(&dummyexpr,p4,p3 - p4);
			zerostring(&initialexpr);
			addsafestr(&initialexpr,&dummyexpr);
			i = eval_expression(dummyexpr.str,0,0,0,7,-3);		
			if(i == 14)
			{
				//sweet deal. eval_expression() recommended a function call addition.
				if(strcmp(str_func_arg.str,p1) == 0)
				{
					//exact match. woohah!
					zerostring(&dummyexpr);
					addsafestr(&dummyexpr,&str_func_arg);
					p1 = initialexpr.str;
					p2 = p4; 
					break;
				}
			}
			p4++;
		}
		if(p2 == 0) return 1; //not cool, can't find a match. (huh?!)
	}


	numquotes = 0;
	for(p3 = pNewLine3->str;p3 < p2; p3++)
	{
		if(*p3 == '\"')
		{
			//we found a quote.
			//backsearch, til we ensure its not escaped.
			for(p4 = p3-1; p4 > pNewLine3->str-1;p4--)
				if(*p4 != '\\') break;

			if((p3 - p4) % 2) numquotes++;
		}
	}

	if(numquotes % 2) 
	{
		//odd number of quotes. find it again, later in the line.
		p3 = p2 + 1;
		goto set_p2_for_replacement;		
	}

	zerostring(&quotedstr);

	p3 = p2-1;
	padding = 0;
	while (1)
	{
/*		if(*p3 == ' ' || *p3 == '\t' || *p3 == '\n')
		{
			padding++;
			p3--;
			continue;
		}
*/		if( *p3 == '(')
		{
			padding++;
			break;
		}
		break;
	}
	addrawstrn(&quotedstr,pNewLine3->str,p2-(pNewLine3->str)-padding);

	addrawstr(&quotedstr,resstr);
	p3 = p2 + strlen(p1);
	padding = 0;
	numparens = 0;
	while (1)
	{
		if(*p3 == ' ' || *p3 == '\t' || *p3 == '\n')
		{
			padding++;
			p3++;
			continue;
		}

		if( *p3 == ')')
		{
			padding++;
			break;
		}
		break;
	}
	addrawstr(&quotedstr,(p2)+strlen(p1)+padding);

	update_list_item_from_safe_str(pNewLine3,&quotedstr);
	killstring(&quotedstr);

	//6:
	force_jump = global_cur_line;
	sub_line_goto = pNewLine1->sub_line_no;

	killstring(&dummyexpr);
	killstring(&initialexpr);

	return 0;
}

int eval_expression(char *str,unsigned long *u_res,signed long *i_res,double *f_res,int type,int has_op)
{
        //ok. we gotta evaluate some math here. yuck.

        //-1.kill whitespace on leader and leading =
        //0. if the string begins with: +-/*^|&, then the string was
        //   an =+ style expression. insert the lvalue.
	//0a.if the first identifier is of type 0 or 1 (function), then all other evaluation elements
	//	following it (up to terminator of line/call-to-eval_expression) are arguments. do not process.
	//	execute the function, and replace the call with its value.
        //1. try to find the insides of array delimeters and work
        //   from inside out.
        //2. find the names of all variables and replace with constants.
        //   (hint: they start with [a-zA-Z_]
        //3. work inside out from parenthases (just like step 1)
	//3y.recheck for function calling like step 0a.
	//3z.move left->right and separate evaluate anything separated by AND or OR
	//	then take the two sides and condense into a 1 or a 0
        //3a.negative expansion: Any minus-sign with a term to the left
        //   (e.g. 5 - 6, not 5 * -3)
        //   should be expanded to '+-'
        //3b.numerical validity check:
        //      values such as '-', '-.', and '.' are killed.
        //4. * and / are evaluated.
        //5. + [and -, but that's already taken care of]
        //6. &, |, ^
	//6a.comparatives. (eq,ne,gt,ge,lt,le) 
        //7. return result.

        SAFESTRING equation;
	SAFESTRING comparestr;
	SAFESTRING safeleft,saferight;
	SAFESTRING quotedstr;
        LPFUNCTIONDEF lpVar=0;
        char opchars[] =   "+-/*^|&";
        int i=0,x=0,digitfound=0;
        long subres;
        double subfres;
        int offset;
	int length;
	long int err;
	int contains_compare=0;
	int contains_strings=0;
        char *p1=0,*p2=0,*p3=0,*p4=0;
        char *subequ=0;
        double op1=0,op2=0;
        unsigned long bop1=0,bop2=0;
        char resstr[32];
        int ismetavar;
	long int compare_error,compres;
	int numquotes;
	int dobrk;
	int persist_op;
	int numparens;

	if(f_res) *f_res = 0;

        p1 = str;
        zerostring(&equation);

	persist_op = -1;
	if(has_op == -3) persist_op = -3;

        //step -1: if it comes with an equalsign on the front, kill it!
        while (*p1 == ' ' || *p1 == '\t') p1++;

        if(*p1 == '=') p1++;
        while(*p1 == ' ' || *p1 == '\t') p1++; //p1 now placed at the beginning of the equation.

	//step 0a /MUST/ be processed inside-first. thus, unless its flat, make sure we're only
	//hitting this on the inner passes.
	if(strchr(str,'(')) goto start_step_1;

	//step 0a: if the identifier at p1 is of type 0 or 1, its a function.
	//the entire rest of the line is a set of arguments to the function.
	//evauate, replace.
	
	if(!isalpha(*p1) && *p1 != '_') goto start_step_1;

	for(p2 = p1;*p2;p2++)
	{
		if (!isalnum(*p2) && *p2 != '_') break; //loop to end of identifier.
	}

	zerostring(&comparestr);
	addrawstrn(&comparestr,p1,p2-p1);
	lpVar = GetUserIdentifier(comparestr.str);
	killstring(&comparestr);
	if(!lpVar) 
	{
		goto start_step_1;
	}
	if(lpVar->type != 0 && lpVar->type != 1) goto start_step_1;

	if(has_op == -2)
	{
		SysErr("Function call is invalid syntax.");
		killstring(&equation);
		return 10;
	}

	if(has_op == -3) 
	{
		//if we're in here, then we're double-checking it.
		zerostring(&str_func_arg);
		addsafestr(&str_func_arg,&equation);
		killstring(&equation);
		return 14;
	}

	//if we're here, then the first identifier is a function!
	//call that on up!
	//note: the *entire* string of p1->end belongs to the function call.

	InsertFunctionCall(p1,p2,2); //p1 points to start of function call. p2 points to first char after func identifier.
	killstring(&equation);
	return 10; //"pause current function for later reprocessing"

start_step_1:
        //now put the rest of the equation into the working string.
        addrawstr(&equation,p1);

	//if the entire equation is a single string,
	//then we have to abort this (return value 11 - autoconvert to string)
	//and escape so we don't fall into a loop track.

	numquotes = 0;
	i = 0;
	for(p1=equation.str;*p1;p1++)
	{
		if(*p1 == '\"')
		{
			for(p2=p1-1;p2>=equation.str;p2--) if(*p2 != '\\') break;
			if((p1-p2)%2) numquotes++; contains_strings = 1;
		}		
		if((isalnum(*p1) || *p1 == '_' || *p1 == '$') && !(numquotes%2)) { i=1; break; } //its not all strings.
	}
	if(!i) 
	{
		//its alllll strings, big guy.
		killstring(&equation);
		return 11; 
	}

        //ok. on to step 1. find something inside [ and ]
        //because recursion is LIFO, we work from the outside in.
        //find the first [ we see and go to the corresponding ]
        //excise the string, and call self with type as 6: internal int.


        p3 = equation.str;
	numquotes = 0;
        do        //loop this in case there're multiple subscripts.
        {

                offset = 0;
                p2 = 0; //p2'll mark the beginning of a [
                i = 0; //depth count.

                for( p1 = p3; *p1 != 0; p1++)
                {
			if(*p1 == '\"')
			{
				for(p4 = p1 - 1; p4 >= equation.str; p4--)
					if(*p4 != '\\') break;
				if((p1 - p4)%2) { numquotes++; contains_strings = 1; } //non-escaped string.
			}
                        if(*p1 == '[' && !p2 && !(numquotes%2)) { p2 = p1+1; }
                        if(*p1 == '[' && !(numquotes%2)) i++;
                        if(*p1 == ']' && !(numquotes%2))
                        {
                                i--;
                                if(!i) break; //we've reached the outside.
                        }
                }        
        
                if(p2)
                {
                        //ok, pull it out and quantify.
                        if(!(*p1)) p1--;
                        subequ = (char *)malloc(p1-p2+1);
                        if(!subequ) { killstring(&equation); return 4; } //out of mem.
                        memset(subequ,0,p1-p2+1);
        
                        strncpy(subequ,p2,p1-p2);
                        x = eval_expression(subequ,&subres,&subres,0,6,persist_op);
			switch (x)
			{
			case 0:
				break;
			case 11:
				//its a string.
				replacestr(&equation,p2-equation.str,p1-p2,str_func_arg.str);
				p3 = p1;
				free(subequ);
				continue;
				break;
			default:
				free(subequ);
				killstring(&equation);
				return x; //error
			}

                        offset = p1 - equation.str;

                        if(subres < 0)
                        {
                                free(subequ);
				killstring(&equation);
                                return 3; //subscript outta bounds.
                        }

                        //now we have what we should replace it with..
                        replacestr(&equation,p2-equation.str,p1-p2,ltoa(subres));

                        p3 = equation.str + offset;

                        free(subequ);
			subequ = 0;
                }
        } while (p2);

        //step two: translate variable names and array names and such
        //into usable numbers. mm. numbers. good things, they are.
        //search for an isalpha(), '$', or '_', isolate to end of term,
        //excise, perform hash lookup, and replacestr.

	//important subnote: any variables INSIDE a set of parenthasis
	//should not be resolved!! (It'll fuck up function calls.)
	//therefore, only root-level (outermost) variables should be dealt with.

        ismetavar = 0;
	numparens = 0;
        for(p1 = equation.str; *p1 != 0; p1++)
        {
		if(*p1 == '\"')
		{
			//first, backsearch for slashes
			//then go to the next quote mark and backsearch for slashes.
			numquotes = 0;
			for(p2 = p1-1;p2 >= equation.str;p2--)
			{
				if(*p1 == '\\') { numquotes++; contains_strings = 1; }
				else break;
			}
			dobrk=0;
			if(numquotes%2 == 0)
			{
				contains_strings = 1;
				//forward search
				for(p2=p1+1;*p2;p2++)
				{
					if(*p2 == '\"')
					{
						numquotes = 0;
						for(p3 = p2-1;p3 >= p1;p3--)
						{
							if(*p3 == '\\') { numquotes++; contains_strings = 1; }
							else break;
						}
        			                if(numquotes%2 == 0)
						{
							p1=p2;
							dobrk = 1;
							break;
						}
					} //found it
				} //for search to find next quote
				if(dobrk) continue;
			} //if not backtic'd
		} //if a quoted string

		if(*p1 == '(') numparens++;
		if(*p1 == ')') numparens--;

                if((isalpha(*p1) || *p1 == '_' || *p1 == '$') && numparens == 0)
                {
                        //we've found a varname start. find the end.
                        for(p2=p1; *p2 != 0; p2++)
                        {
                                if(*p2 == '$' && p2 == p1)
                                {
                                        ismetavar = 1;
                                        continue;
                                }
                                if(ismetavar && (*p2 == '#' || *p2 == '*' || *p2 == '.')) continue;
                                if(!isalnum(*p2) && *p2 != '[' && *p2 != ']' && *p2 != '_') { break; }
                        }

                        //now p1 is the start and p2 is the end..
                        //capture the varname into subequ.
                        subequ = (char *)malloc(p2-p1+1);
                        if(!subequ) { killstring(&equation); return 4; }
                        memset(subequ,0,p2-p1+1);
                        strncpy(subequ,p1,p2-p1);
			if(strncmp(subequ,"eq",2)==0 ||
			   strncmp(subequ,"is",2)==0 ||
			   strncmp(subequ,"ne",2)==0 ||
			   strncmp(subequ,"le",2)==0 ||
			   strncmp(subequ,"lt",2)==0 ||
			   strncmp(subequ,"ge",2)==0 ||
			   strncmp(subequ,"gt",2)==0)
			{
				free(subequ);
				subequ = 0;
				p1 = p2;
				contains_compare=1;
				continue;
			}
			if(strncmp(subequ,"and",3)==0 ||
			   strncmp(subequ,"or",2) ==0)
			{
				free(subequ);
				subequ = 0;
				p1 = p2;
				continue;
			}

                        lpVar = GetUserIdentifier(subequ);
                        free(subequ);
			subequ = 0;
                        if(!lpVar) { killstring(&equation); return 2; } //invalid identifier
                        switch(lpVar->type)
                        {
			case 0:
			case 1:
				//ignore functions. leave em as is, to evaluate.
				p1 = p2;
				continue;
				break;
                        case 2:
                                memset(resstr,0,32);
                                sprintf(resstr,"%g",lpVar->val.float_val);
                                replacestr(&equation,p1-equation.str,p2-p1,resstr);
                                break;
                        case 3:
                                replacestr(&equation,p1-equation.str,p2-p1,ltoa(lpVar->val.long_val));
                                break;
                        case 4:
                                replacestr(&equation,p1-equation.str,p2-p1,ltoa(lpVar->val.ulong_val));
                                break;
			case 5:
				//ok, this one's a mite bit tricky.
				//if the string begins with a digit, a dot, or a negsign,
				//(and the dot/neg is followed by a digit), then we perform 
				//a strtod() conversion and replacestr w/ that.
				//NOTE VERSION 0.5.6 -- THIS IS SUPERCEDED; USE STRONG TYPING
				//NOW THAT tostr AND toval FUNCTIONS EXIST
	
				contains_strings = 1;
	
				//its a real string. dump in the string within quotes.
	
				zerostring(&quotedstr);
				addrawstr(&quotedstr,"\"");
				addsafestr(&quotedstr,lpVar->val.str_val);
				addrawstr(&quotedstr,"\"");
				replacestr(&equation,p1-equation.str,p2-p1,quotedstr.str);
				killstring(&quotedstr);
				if(has_op != -1) { killstring(&equation); return 11; } //should be computed as a string.
//printf("Equation dropped in: <%s>\n",equation.str);
				break;	
                        default:
				killstring(&equation);
                                return 6;
                        } //switch var type
                        p1 = equation.str-1;
                } //if found a var
        } //run thru string...

        //step three: see that code up there? yeah. from step one.
        // s/[/(/g and s/]/)/g and recycle ;)

        do        //loop this in case there're multiple subscripts.
        {
		numquotes = 0;
                p2 = 0; //p2'll mark the beginning of a (
                i = 0; //depth count.
        
                
                for( p1 = equation.str; *p1 != 0; p1++)
                {
			if(*p1 == '\"')
			{
				for(p4 = p1 - 1; p4 >= equation.str; p4--)
					if(*p4 != '\\') break;
				if((p1 - p4)%2) { numquotes++; contains_strings = 1; } //non-escaped string.
			}
                        if(*p1 == '(' && !p2 && !(numquotes%2)) { p2 = p1+1; }
                        if(*p1 == '(' && !(numquotes%2)) i++;
                        if(*p1 == ')' && !(numquotes%2))
                        {
                                i--;
                                if(!i) break; //we've reached the outside.
                        }
                }        
        
                if(p2)
                {
                        //ok, pull it out and quantify.
                        subequ = (char *)malloc(p1-p2+1);
                        if(!subequ) { killstring(&equation); return 4; } //out of mem.
                        memset(subequ,0,p1-p2+1);
        
                        strncpy(subequ,p2,p1-p2);
                        subres = 0;
                        subfres = 0;
                        x = eval_expression(subequ,&subres,&subres,&subfres,7,persist_op);
                        switch (x)
                        {
                        case 0:
                                break;
                        case 11:
                                //its a string
				offset = 0;
				length = 0;
				if(*(p2-1) == '(') { offset = 1; length = 1;}
				if(*(p1) == ')') length++;
                                replacestr(&equation,p2-equation.str-offset,p1-p2+length,str_func_arg.str);
                                p3 = p1;
				free (subequ);
				continue;
                                break;
                        default:
				free(subequ);
				killstring(&equation);
                                return x; //error
                        }

        
                        //now we have what we should replace it with..
                        p2--;
                        memset(resstr,0,32);
                        if(subres && !subfres)
                                sprintf(resstr,"%ld",subres);
                        else
                                sprintf(resstr,"%g",subfres);

                        replacestr(&equation,p2-equation.str,p1-p2+1,resstr);
                        free(subequ);
			subequ = 0;
                }

        } while (p2);

	//step 3y. Double-check for function calling!
	//okay, at this time, we've worked out any inner parenthases.
	//but now we have to RECHECK to see if they were for sub-params to a function
	//that we need to set up for the user as a function call!

	for(p1=equation.str;*p1;p1++) if(*p1 != ' ' && *p1 != '\t') break;
        if(!isalpha(*p1) && *p1 != '_') goto start_step_3z;

        for(p2 = p1;*p2;p2++)
        {
                if (!isalnum(*p2) && *p2 != '_') break; //loop to end of identifier.
        }

        zerostring(&comparestr);
        addrawstrn(&comparestr,p1,p2-p1);
        lpVar = GetUserIdentifier(comparestr.str);
        killstring(&comparestr);
        if(!lpVar) goto start_step_3z;
        if(lpVar->type != 0 && lpVar->type != 1) goto start_step_3z;

        if(has_op == -2)
        {
                SysErr("Function call is invalid syntax.");
		killstring(&equation);
                return 10;
        }

	if(has_op == -3) 
	{
		//if we're in here, then we're double-checking it.
		zerostring(&str_func_arg);
		addsafestr(&str_func_arg,&equation);
		killstring(&equation);
		return 14;
	}

        //if we're here, then the first identifier is a function!
        //call that on up!
        //note: the *entire* string of p1->end belongs to the function call.

        InsertFunctionCall(p1,p2,2); //p1 points to start of function call. p2 points to end of func identifier.
	killstring(&equation);
        return 10; //"pause current function for later reprocessing"


start_step_3z:

	//step 3z. AND and OR separation
	//if we run into one, we gotta evaluate everything on ONE side of it at a time.
	//after we eval both sides, condense the whole thing into a one or a zero.
	p4 = equation.str;

	p1 = strstr(p4,"and");
	if(p1)
	{
retest_and:
		//first, determine if its a separate term (bounded by spaces or tabs)
		if( (*(p1-1) != ' ' && *(p1-1) != '\t') ||
		    (*(p1+3) != ' ' && *(p1+3) != '\t'))
		{
			p4 = p1+1;
			p1 = strstr(p4,"and");
			if(p1) { goto retest_and; }
			else { goto contains_no_and; }
		}

		//okay. now we have to determine if the `and' is in a quoted str
		//or not..

		numquotes = 0;
		for(p2 = equation.str;p2 < p1;p2++)
		{
			if(*p2 == '\"')
			{
				//quote found. is it a legit one?
				for(p3=p2-1;p3>equation.str-1;p3--)
				{
					if(*p3 != '\\') break;
				}
				if((p2-p3) % 2) { numquotes++; contains_strings = 1; }
			}
		}

		if(numquotes % 2)
		{
			p4 = p1+1;
			p1 = strstr(p4,"and");
			if(p1) { goto retest_and; }
			else { goto contains_no_and; }
		}

		//yes, s'all good! separate each half-expression into two new safestrings
		//pass them thru the evaluator
		//if both sides are not zero, then the whole expression is set to one.
		//else, whole expression is set to zero.

		zerostring(&safeleft);
		zerostring(&saferight);

		addsafestrn(&safeleft,&equation,p1-equation.str);
		addrawstr(&saferight,p1+3);

		subres = subfres = 0;
		if(persist_op == -1) persist_op = 0;
		err = eval_expression(safeleft.str,&subres,&subres,&subfres,7,persist_op);
		if(err && err != 11)
		{
			killstring(&safeleft);
			killstring(&saferight);
			killstring(&equation);
			return err;	
		}
		i = subres + subfres;

		err = eval_expression(saferight.str,&subres,&subres,&subfres,7,persist_op);
		killstring(&safeleft);
		killstring(&saferight);
		if(err) { killstring(&equation); return err; }
	
		if(subres && !subfres) subfres = subres;

		killstring(&equation);
		zerostring(&equation);


		if(i && subfres) { addrawstr(&equation,"1"); }
		else { addrawstr(&equation,"0"); }

		goto immediate_end;
		
	}

contains_no_and:

	p4 = equation.str;

	p1 = strstr(p4,"or");
	if(p1)
	{
retest_or:
		//first, determine if its a separate term (bounded by spaces or tabs)
		if( (*(p1-1) != ' ' && *(p1-1) != '\t') ||
		    (*(p1+2) != ' ' && *(p1+2) != '\t'))
		{
			p4 = p1+1;
			p1 = strstr(p4,"or");
			if(p1) { goto retest_or; }
			else { goto no_and_or ; }
		}

		//okay. now we have to determine if the `and' is in a quoted str
		//or not..

		numquotes = 0;
		for(p2 = equation.str;p2 < p1;p2++)
		{
			if(*p2 == '\"')
			{
				//quote found. is it a legit one?
				for(p3=p2-1;p3>equation.str-1;p3--)
				{
					if(*p3 != '\\') break;
				}
				if((p2-p3) % 2) { numquotes++; contains_strings = 1; }
			}
		}

		if(numquotes % 2)
		{
			p4 = p1+1;
			p1 = strstr(p4,"or");
			if(p1) { goto retest_or; }
			else { goto no_and_or; }
		}

		//its kosher. separate each half-expression into two new safestrings
		//pass them thru the evaluator
		//if both sides are not zero, then the whole expression is set to one.
		//else, whole expression is set to zero.

		zerostring(&safeleft);
		zerostring(&saferight);

		addsafestrn(&safeleft,&equation,p1-equation.str);
		addrawstr(&saferight,p1+2);

		if(persist_op == -1) persist_op = 0;
		subres = subfres = 0;
		err = eval_expression(safeleft.str,&subres,&subres,&subfres,7,persist_op);
		if(err)
		{
			killstring(&safeleft);
			killstring(&saferight);
			killstring(&equation);
			return err;	
		}
	
		i = subres + subfres;

		err = eval_expression(saferight.str,&subres,&subres,&subfres,7,persist_op);
		killstring(&safeleft);
		killstring(&saferight);
		if(err) { killstring(&equation); return err; }
	
		if(subres && !subfres) subfres = subres;

		killstring(&equation);
		zerostring(&equation);

		if(i || subfres) { addrawstr(&equation,"1"); }
		else { addrawstr(&equation,"0"); }

		goto immediate_end;
	}	

no_and_or:

	if(contains_strings && !contains_compare)
	{
		//time to replace the current expression with the 
		//equated version of it all.
		zerostring(&quotedstr);
		do_string_eval_work(&equation,&quotedstr);
		zerostring(&equation);
		addsafestr(&equation,&quotedstr);
		killstring(&quotedstr);	
	}

	if(contains_strings && contains_compare)
	{
		err = 0;
		subres = DoStringCompare(equation.str,&err);
		if(err) { killstring(&equation); return err; }
		zerostring(&equation);
		addrawstr(&equation,ltoa(subres));
		goto immediate_end;
	}

        //step 3a. minus expansion
        for(p1 = equation.str+1; *p1; p1++)
        {
                if(p1 == equation.str) continue;
                if(*p1 == '-')
                {
                        if(*(p1+1) == '-')
                        {
                                //make -- -> +
                                replacestr(&equation,p1-equation.str,2,"+");
                                p1 = equation.str;
                                continue;
                        }
                        for(p2 = p1-1;*p2;p2--)
                        {
                                if(*p2 == ' ' || *p2 == '\t') continue;
                                if(*p2 == '.' || isdigit(*p2))
                                {
                                        //we should replace.
                                        //also, gotta delete whitespace ahead of the minus.
                                        for(p3 = p1+1;*p3;p3++)
                                        {
                                                if(*p3 != ' ' && *p3 != '\t') break; 
                                        }
                                        replacestr(&equation,p1-equation.str,p3-p1,"+-");
                                        p1 = equation.str;
                                        break;
                                }
                                for(p3 = opchars; *p3; p3++)
                                        if(*p2 == *p3) break;
                                if(*p2 == *p3) break;
                                if(p2 == equation.str) break;
                        } //loop back and look for term
                } //we found a minus
        } //minus expansion

        //3b: numerical validity check.
        for(p1 = equation.str; *p1; p1++)
        {
                if(*p1 == '.')
                {
                        if( !isdigit(*(p1+1)) && !isdigit(*(p1-1)) )
                        {
                                //no digit to left or right of a dot
                                //so we have '.' or '-.' being used as a num.
				killstring(&equation);
                                return 9;
                        }
                }
                if(*p1 == '-')
                {
                        if( !isdigit(*(p1+1)) )
                        {
                                //no digit to right of a neg sign
				killstring(&equation);
                                return 9;
                        }
                }
        } //numerical validity


        //step four: wow. its time to do math. division and multiplication.
        for(p1 = equation.str; *p1 != 0; p1++)
        {
                if(*p1 == '*')
                {
                        //we've found a mul. backsearch for prev const,
                        //forwardsearch for next constant. multiply and
                        //replace.

                        //first, backsearch..
                        digitfound = 0;
                        for(p2 = p1-1; *p2 != 0; p2--)
                        {
                                if(p2 == equation.str)
                                {
                                        if(!isdigit(*p2) && *p2 != '.' && *p2 != '-')
						{ killstring(&equation); return 5; }
                                        goto compute_mul;
                                }
                                if(isdigit(*p2)) digitfound = 1;
                                if(*p2 == ' ' || *p2 == '\t')
                                {
                                        if(!digitfound) continue;
                                        else { p2++; goto compute_mul; } 
                                }
                                if(!isdigit(*p2) && *p2 != '.' && *p2 != '-')
                                {
                                        if(p1-p2 == 1)
						{ killstring(&equation); return 5; }
                                        p2++;
compute_mul:
                                        op1 = atof(p2);
                                        break;
                                }
                        }

                        while(!isdigit(*p1) && *p1 != '.' && *p1 != '-' && *p1 != 0) p1++;

                        if( !(*p1) ) { killstring(&equation); return 5; }

                        //forward search.
                        digitfound = 0;
                        for(p3 = p1; *p3 != 0; p3++)
                        {
                                if(isdigit(*p3) || *p3 == '.') digitfound=1;
                                if(!isdigit(*p3) && *p3 != '.' && *p3 != '-') break;
                                if(digitfound && *p3 == '-') break;
                        }

                        op2 = atof(p1);


                        op1 = op1 * op2;
                        memset(resstr,0,32);
                        sprintf(resstr,"%g",op1);
                        replacestr(&equation,p2-equation.str,p3-p2,resstr);

                        p1 = equation.str;
                } //if we should mul
                if(*p1 == '/')
                {
                        //we've found a div. backsearch for prev const,
                        //forwardsearch for next constant.
                        //isolate, check for div/0, divide and conquor.

                        //first, backsearch..
                        digitfound=0;
                        for(p2 = p1-1; *p2 != 0; p2--)
                        {
                                if(p2 == equation.str)
                                {
                                        if(!isdigit(*p2) && *p2 != '.' && *p2 != '-')
                                                { killstring(&equation); return 5; } 
                                        goto compute_div;
                                }
                                if(isdigit(*p2)) digitfound = 1;
                                if(*p2 == ' ' || *p2 == '\t')
                                {
                                        if(!digitfound) continue;
                                        else { p2++; goto compute_div; } 
                                }
                                if(!isdigit(*p2) && *p2 != '.' && *p2 != '-')
                                {
                                        if(p1-p2 == 1)
                                                { killstring(&equation); return 5; }
                                        p2++;
compute_div:
                                        op1 = atof(p2);
                                        break;
                                }
                        }

                        while(!isdigit(*p1) && *p1 != '.' && *p1 != '-' && *p1 != 0) p1++;

                        if( !(*p1) ) { killstring(&equation); return 5; }

                        //forward search.
                        digitfound = 0;
                        for(p3 = p1; *p3 != 0; p3++)
                        {
                                if(isdigit(*p3) || *p3 == '.') digitfound=1;
                                if(!isdigit(*p3) && *p3 != '.' && *p3 != '-') break;
                                if(digitfound && *p3 == '-') break;
                        }

                        op2 = atof(p1);

                        if(op2 == 0) { killstring(&equation); return 7; }

                        op1 = op1 / op2;
                        memset(resstr,0,32);
                        sprintf(resstr,"%g",op1);
                        replacestr(&equation,p2-equation.str,p3-p2,resstr);

                        p1 = equation.str;
                } //if we should div
        } //loop for muls and divs


        //step five: and adding and subtracting...
        for(p1 = equation.str; *p1 != 0; p1++)
        {
                if(*p1 == '+')
                {
                        //we've found an add. backsearch for prev const,
                        //forwardsearch for next constant. multiply and
                        //replace.

                        //first, backsearch..
                        digitfound = 0;
                        for(p2 = p1-1; *p2 != 0; p2--)
                        {
                                if(p2 == equation.str)
                                {
                                        if(!isdigit(*p2) && *p2 != '.' && *p2 != '-')
                                                { killstring(&equation); return 5; }
                                        goto compute_add;
                                }
                                if(isdigit(*p2)) digitfound = 1;
                                if(*p2 == ' ' || *p2 == '\t')
                                {
                                        if(!digitfound) continue;
                                        else { p2++; goto compute_add; } 
                                }
                                if(!isdigit(*p2) && *p2 != '.' && *p2 != '-')
                                {
                                        if(p1-p2 == 1)
                                                { killstring(&equation); return 5; } 
                                        p2++;
compute_add:
                                        op1 = atof(p2);
                                        break;
                                }
                        }

                        p1++;
                        while(!isdigit(*p1) && *p1 != '.' && *p1 != '-' && *p1 != 0) p1++;

                        if( !(*p1) ) { killstring(&equation); return 5; } 

                        //forward search.
                        digitfound = 0;
                        for(p3 = p1; *p3 != 0; p3++)
                        {
                                if(isdigit(*p3) || *p3 == '.') digitfound=1;
                                if(!isdigit(*p3) && *p3 != '.' && *p3 != '-') break;
                                if(digitfound && *p3 == '-') break;
                        }

                        op2 = atof(p1);

                        op1 = op1 + op2;
                        memset(resstr,0,32);
                        sprintf(resstr,"%g",op1);
                        replacestr(&equation,p2-equation.str,p3-p2,resstr);

                        p1 = equation.str;
                } //if we should add
        } //loop for add [and sub.]

        //step six: bitwise stuffage. ^ | &
        for(p1 = equation.str; *p1 != 0; p1++)
        {
                if(*p1 == '&')
                {
                        if(type == 2) { killstring(&equation); return 8; }
                        if(type == 7) type = 6;
			if(type == 12) { type = 6; contains_compare = 0; }

                        //we've found an and. backsearch for prev const,
                        //forwardsearch for next constant. multiply and
                        //replace.

                        //first, backsearch..
                        digitfound = 0;
                        for(p2 = p1-1; *p2 != 0; p2--)
                        {
                                if(p2 == equation.str)
                                {
                                        if(!isdigit(*p2) && *p2 != '.')
                                                { killstring(&equation); return 5; }
                                        goto compute_and;
                                }
                                if(isdigit(*p2)) digitfound = 1;
                                if(*p2 == ' ' || *p2 == '\t')
                                {
                                        if(!digitfound) continue;
                                        else { p2++; goto compute_and; } 
                                }
                                if(!isdigit(*p2))
                                {
                                        if(p1-p2 == 1)
                                                { killstring(&equation); return 5; }
                                        p2++;
compute_and:
                                        bop1 = atol(p2);
                                        break;
                                }
                        }

                        while(!isdigit(*p1) && *p1 != '.' && *p1 != 0) p1++;

                        if( !(*p1) ) { killstring(&equation); return 5; }

                        //forward search.
                        for(p3 = p1; *p3 != 0; p3++)
                                if(!isdigit(*p3) && *p3 != '.') break;

                        bop2 = atol(p1);

                        bop1 = bop1 & bop2;

                        replacestr(&equation,p2-equation.str,p3-p2,ltoa(bop1));

                        p1 = equation.str;
                } //if we should and
                if(*p1 == '|')
                {
                        if(type == 2) { killstring(&equation); return 8; }
                        if(type == 7) type = 6;
			if(type == 12) { type = 6; contains_compare = 0; }
                        
                        //we've found an or. backsearch for prev const,
                        //forwardsearch for next constant.

                        //first, backsearch..
                        digitfound = 0;
                        for(p2 = p1-1; *p2 != 0; p2--)
                        {
                                if(p2 == equation.str)
                                {
                                        if(!isdigit(*p2) && *p2 != '.')
                                                { killstring(&equation); return 5; }
                                        goto compute_or;
                                }
                                if(isdigit(*p2)) digitfound = 1;
                                if(*p2 == ' ' || *p2 == '\t')
                                {
                                        if(!digitfound) continue;
                                        else { p2++; goto compute_or; } 
                                }
                                if(!isdigit(*p2))
                                {
                                        if(p1-p2 == 1)
                                                 { killstring(&equation); return 5; }
                                        p2++;
compute_or:
                                        bop1 = atol(p2);
                                        break;
                                }
                        }

                        while(!isdigit(*p1) && *p1 != '.' && *p1 != 0) p1++;

                        if( !(*p1) ) { killstring(&equation); return 5; }
                        //forward search.
                        for(p3 = p1; *p3 != 0; p3++)
                                if(!isdigit(*p3) && *p3 != '.')
                                        break;

                        bop2 = atof(p1);

                        bop1 = bop1 | bop2;
                        replacestr(&equation,p2-equation.str,p3-p2,ltoa(bop1));

                        p1 = equation.str;
                } //if we should or
                if(*p1 == '^')
                {
                        if(type == 2) { killstring(&equation); return 8; }
                        if(type == 7) type = 6;
			if(type == 12) { type = 6; contains_compare = 0; }

                        //we've found an xor. backsearch for prev const,
                        //forwardsearch for next constant.

                        //first, backsearch..
                        digitfound = 0;
                        for(p2 = p1-1; *p2 != 0; p2--)
                        {
                                if(p2 == equation.str)
                                {
                                        if(!isdigit(*p2) && *p2 != '.')
                                                { killstring(&equation); return 5; }
                                        goto compute_xor;
                                }
                                if(isdigit(*p2)) digitfound = 1;
                                if(*p2 == ' ' || *p2 == '\t')
                                {
                                        if(!digitfound) continue;
                                        else { p2++; goto compute_xor; } 
                                }
                                if(!isdigit(*p2))
                                {
                                        if(p1-p2 == 1)
                                                { killstring(&equation); return 5; }
                                        p2++;
compute_xor:
                                        bop1 = atof(p2);
                                        break;
                                }
                        }

                        while(!isdigit(*p1) && *p1 != '.' && *p1 != 0) p1++;

                        if( !(*p1) ) { killstring(&equation); return 5; }

                        //forward search.
                        for(p3 = p1; *p3 != 0; p3++)
                                if(!isdigit(*p3) && *p3 != '.')
                                        break;

                        bop2 = atof(p1);

                        bop1 = bop1 ^ bop2;
                        replacestr(&equation,p2-equation.str,p3-p2,ltoa(bop1));

                        p1 = equation.str;
                } //if we should xor
        } //loop for and, or, xor

	//step 6a: comparison operators
	if(contains_compare && type != 12)
	{
		p4 = equation.str;
find_compare_operator:
		p1=strstr(p4,"eq");
		if(!p1) p1=strstr(p4,"is");
		if(!p1) p1=strstr(p4,"ne");
		if(!p1) p1=strstr(p4,"gt");
		if(!p1) p1=strstr(p4,"ge");
		if(!p1) p1=strstr(p4,"lt");
		if(!p1) p1=strstr(p4,"le");
		if(p1)
		{
			//at this point, we need to doublecheck to make sure the comparator
			//is not in a string. so, do so now :)
			numquotes = 0;
			for(p2 = equation.str;p2<p1;p2++)
			{
				if(*p2 == '\"')
				{
					for(p3=p2-1;p3>=equation.str;p3--)
						if(*p3 != '\\') break;
					if((p3-p2)%2) numquotes++;
				}
			}
			if(numquotes%2) { p4 = p1 + 1; goto find_compare_operator; }

                        //first, backsearch..
                        digitfound = 0;
                        for(p2 = p1-1; p2 >= equation.str; p2--)
                        {
                                if(p2 == equation.str)
                                {
                                        if(!isdigit(*p2) && *p2 != '.' && *p2 != '-')
                                                 { killstring(&equation); return 5; }
                                        goto compute_compare;
                                }
                                if(isdigit(*p2)) digitfound = 1;
                                if(*p2 == ' ' || *p2 == '\t')
                                {
                                        if(!digitfound) continue;
                                        else { p2++; goto compute_compare; }
                                }
                                if(!isdigit(*p2) && *p2 != '.' && *p2 != '-')
                                {
                                        if(p1-p2 == 1)
                                                 { killstring(&equation); return 5; }
                                        p2++;
compute_compare:
                                        op1 = atof(p2);
                                        break;
                                }
                        }

                        p1++;
                        while(!isdigit(*p1) && *p1 != '.' && *p1 != '-' && *p1 != 0) p1++;

                        if( !(*p1) ) { killstring(&equation); return 5; }

                        //forward search.
                        digitfound = 0;
                        for(p3 = p1; *p3 != 0; p3++)
                        {
                                if(isdigit(*p3) || *p3 == '.') digitfound=1;
                                if(!isdigit(*p3) && *p3 != '.' && *p3 != '-') break;
                                if(digitfound && *p3 == '-') break;
                        }

			//ok, the string that we're gonna compare with is between p2 and p3
			//isolate into a string, send off for processing,
			//and replace.
			zerostring(&comparestr);
			addrawstrn(&comparestr,p2,p3-p2);
			compare_error=0;
			compres=DoCompareWork(comparestr.str,&compare_error);
			killstring(&comparestr);	
			if(compare_error) { killstring(&equation); return compare_error; }
			replacestr(&equation,p2-equation.str,p3-p2,ltoa(compres));
		}
	}



	contains_compare = 0;

	//at this point, we need to determine if anything's left.
	for(p1=equation.str;*p1;p1++)
	{
//		if(isalpha(*p1)) contains_compare=1;
//		for(i=0;i<7;i++) if(*p1 == opchars[i]) contains_compare = 1;
//		if(*p1 == '(' || *p1 == ')') contains_compare = 1;
	}

	if(contains_compare)
	{
		//something's still in the string.
		subequ = malloc(strlen(equation.str));
		memset(subequ,0,strlen(equation.str));
		strcpy(subequ,equation.str);
		if(persist_op == -1) persist_op = 0;
		err = eval_expression(subequ,&subres,&subres,&subfres,6,persist_op);
		if(err == 11) 
		{
			free(subequ);
			killstring(&equation);
			return 11;
		}
		if(subfres && !subres) subres = subfres;
		zerostring(&equation);
		memset(resstr,0,32);
		sprintf(resstr,"%ld",subres);
		addrawstr(&equation,resstr);
		free(subequ);
	}

	

immediate_end:
        //and finally, return the result!
        switch(type)
        {
        case 2: //float
        case 7: //internal float
	case 12: //internal non-comparative float
		if(f_res)
	                *f_res = atof(equation.str);
                break;
        case 3: //user int
        case 6: //internal int
		if(i_res)
	                *i_res = atol(equation.str);
                break;
        case 4: //user uint
		if(i_res)
		{
		        *i_res = atol(equation.str);
                	if (*i_res < 0) *i_res = 0 - (*i_res); //make it positive..
		}
		if(u_res)
			*u_res = (unsigned long) atol(equation.str);
                break;
        }

	if(contains_strings)
	{
		//at this point, we know that the original function contained strings.
		//does it still? (They may have reduced into a comparison 1/0.)
		//check for it.
		if(strchr(equation.str,'\"'))
		{
			zerostring(&str_func_arg);
			addrawstr(&str_func_arg,"\"");
			addsafestr(&str_func_arg,&equation);
			addrawstr(&str_func_arg,"\"");
			return 11; //is a string-based expression
		}
	}


	killstring(&equation);

        return 0; //return success.
}

int create_user_variables(char *str,LPSAFELISTITEM pThisLine,int var_type,int domain)
{
     //create and init variables

     //syntax:
     //[{local | const}] {string | [u]int[eger] | real} [array] var [= val] [, var = val...];

        char varname[41];
        char curname[41];
        char tempstr[32];
        char *p1=0,*p2=0,*p3=0,*p4=0,*p5=0,*p6=0,*p7=0;
        char *sv1=0,*sv2=0;
        char *n1=0;
        char *a1=0,*a2=0;
        int found_space=0;
        int found=0;
        int offset;
        int c = 0;
        int numquotes=0;
        int numslashes=0;
        int numbrackets=0;
        int namemax;
        LPFUNCTIONDEF lpNextFunc;
        LPFUNCTIONDEF lpParentFunc;
        SAFESTRING varstr;
        SAFESTRING subequstr;
        unsigned long varhash=0;
        long intres;
        double floatres;
        int array = 0;
        int ret;
	int isconst = 0;

        zerostring(&varstr);

	//determine if this is a constant, by the type.
	if(var_type >= 14 && var_type <= 17)
	{
		isconst = 1;	//set constant flag.
		var_type -= 12; //degenerate into standard type.
	}

        namemax = 40;
        //first things first:
        //check if we're initializing an array.
        p1 = str;
        while(*p1)
        {
                if(*p1 == ' ' || *p1 == '\t') { p1++; }
                else { break; }
        }
        if(strncmp(p1,"array ",6) == 0 || strncmp(p1,"array\t",6) == 0)
        {
                //yeap!
		//note: if this is a constant, die here (Const arrays not allowed!)
		if(isconst)
		{
			SysErr("Constant arrays not supported.");
			killstring(&varstr);
			return 1;
		}
                var_type = var_type + 6; //switch to array mode.
                array = 1;
                p1 += 6;
                namemax = 28;
        }                 

        //now find the var/array names themselves.
        p5 = p7 = p1;
        p1 = 0;

        while(p5)
        {
                //trim leading whitespace
                for( p3 = p5; *p3 != 0; p3++)
                {
                        if(!isalpha(*p3) && *p3 != '_' && *p3 != ' ' && *p3 != '\t')
                        {
				SysErr("Illegal characters in identifier.");
                                killstring(&varstr);
                                return 1;
                        }
                        if(isalpha(*p3) || *p3 == '_') break; //found start
                }
        
                //find where the func name ends, and if there's an initializer.
                for( p2=p3 ; *p2 != 0; p2++) //run thru the string.
                {
                        if(*p2 == '=')
                        {
                                p1 = p2+1;
                                //now check for a comma really quickly..
                                for(p6 = p2+1;*p6 != 0;p6++)
				{
                                        if(var_type > 7)
                                        {
                                                //we're in an array
                                                if(var_type < 11)
                                                {
                                                        //array of nums
                                                        if(*p6 == '}') numbrackets++;
                                                        if(*p6 == '{') numbrackets--;
                                                }
                                                else
                                                {
                                                        //array of strs
                                                        if(*p6 == '\"')
                                                        {
                                                                numslashes=0;
                                                                for(n1 = p6-1;n1 > p2;n1--)
                                                                {
                                                                        if(*n1 == '\\') numslashes++;
                                                                        else break;
                                                                }
                                                                if(!(numslashes%2)) numquotes++;
                                                        }
                                                        if(*p6 == '{' && !(numquotes%2)) numbrackets++;
                                                        if(*p6 == '}' && !(numquotes%2)) numbrackets--;
                                                }
                                                if(numbrackets > 1)
                                                {
                                                        SysErr("Invalid array initializer");
                                                        killstring(&varstr);
                                                        return 1;
                                                }
                                                if(*p6 == ',')
                                                {
                                                        if(var_type == 11 && numquotes % 2) continue;
                                                        if(numbrackets) continue;
                                                        p5 = p6 + 1;
                                                        break;
                                                }
                                        }
                                        if(var_type == 5 && *p6 == '\"')
                                        {
                                                numslashes=0;
                                                for(n1 = p6-1;n1 > p2;n1--)
                                                {
                                                        if(*n1 == '\\') numslashes++;
                                                        else break;
                                                }
                                                if(!(numslashes%2)) numquotes++;
                                        }
                                        if(*p6 == ',') 
					{ 
						if(var_type == 5 && numquotes % 2) continue;
						p5 = p6+1;
						break; 
					}
				}
                                break;
                        }
                        if(*p2 == ',') { p5 = p2+1; break; }
                }
        
                memset(varname,0,41);
        
                if(p2-p3 > namemax)
                {
			SysErr("Identifier too long.");
                        killstring(&varstr);
                        return 1;
                }
        
                strncpy(varname,p3,p2-p3); //capture the var name.
        
                //kill trailing whitespace.
                found_space = 0;
                for(p4 = varname; *p4 != 0; p4++)
                {
                        if(*p4 == '\t' || *p4 == ' ')
                        {
                                *p4 = 0;
                                found_space = 1;
                        }
                        if(isalnum(*p4) && found_space)
                        {
                                //you can't have spaces in names..
				SysErr("Illegal characters in identifier.");
                                killstring(&varstr);
                                return 1;
                        }
                }
        
                //check legality of the name..
                for(p4 = varname; *p4 != 0; p4++)
                {
                        if(!isalnum(*p4) && *p4 != '_')
                        {
				SysErr("Illegal characters in identifier.");
                                killstring(&varstr);
                                return 1;
                        }
                }

                //and the last check left:
                //is that name taken?
                varhash = strhash(varname);
                lpNextFunc = pFirstFunc;
                found = 0;
                while(lpNextFunc)
                {
                        if(lpNextFunc->hash == varhash) 
                        {
				if(!strcmp(lpNextFunc->name,varname))
				{
					if(lpNextFunc->type == 0) found = 1; //replacing intrinic value = no-no.
					if(lpNextFunc->domain == domain) found = 1;
                	                break;
				}
                        }
                        lpNextFunc = lpNextFunc->next;                   
                } //while we have functions to check for the hash
                if(found)
                {
			SysErr("Identifier already defined.");
                        killstring(&varstr);
                        return 1;
                } //if the name's taken.

                //ok, its legal, damnit! create it (finally...)
		if(isconst)
			{ create_intrinsic_function(varname,0);	}
		else
		{
	                switch(var_type)
        	        {
                	case 5:
                        	create_intrinsic_function(varname,__user_eval_string);
	                        break;
        	        default:
                	        create_intrinsic_function(varname,__user_eval_expression);
	                }
		}

                pLastFunc->type = var_type; 
                pLastFunc->domain = domain;

                lpParentFunc = pLastFunc;

                if(var_type == 5)
                {
                        pLastFunc->val.str_val = malloc(sizeof(SAFESTRING));
                        if(!pLastFunc->val.str_val) 
                        {
                                SysErr("Out of memory");
                                killstring(&varstr);
                                return 1;
                        }
                        zerostring(pLastFunc->val.str_val);
                } //if we need to create the string holder.

                //should we initialize it?
                if(p1 > p3)
                {
                        while(*p1 == ' ' || *p1 == '\t') p1++;

                        //ok
                        //right here, we're about to use the initializer for a variable.
                        //this is where we would expand a varname (if it starts with A-Z
                        //or _, etc.) into the number/string/etc..

                        zerostring(&varstr);

                        //isolate to end of term, capture, and transmute
                        //then put it into a safestring.
                        //take sv1 (!) and point it to the safestr.
                        //if its a numerical equation, evaluate and replace into safestr
                        //if its a string, don't.
                        //if its an -array- of equations, eval separately and replace
                        //              (yuck)

                        numbrackets=0;
                        numquotes=0;
                        for(sv1=p1;*sv1;sv1++)
                        {
                                if(*sv1 == '{' && !(numquotes%2))
                                {
                                        if(numbrackets)
                                        {
                                                killstring(&varstr);
                                                SysErr("Bracket mismatch.");
                                                return 1;
                                        }
                                        numbrackets++;
                                }
                                if(*sv1 == '}' && !(numquotes%2))
                                {
                                        if(numbrackets != 1)
                                        {
                                                killstring(&varstr);
                                                SysErr("Bracket mismatch.");
                                                return 1;
                                        }
                                        numbrackets++;
                                }
                                if(*sv1 == '\"')
                                {
                                        numslashes=0;
                                        for(sv2=sv1;sv2 > p1;sv2--)
                                        {
                                                if(*sv2 != '\\') break;
                                                numslashes++;
                                        }
                                        if(!(numslashes%2)) numquotes++;
                                }

                                if(*sv1 == ',' && !(numbrackets%2) && !(numquotes%2)) break;
                        }

                        //sv1 is now the end; p1 is beginning.
                        addrawstrn(&varstr,p1,sv1-p1);
                        sv1 = varstr.str;

                        //evaluate the equation if we need to.
                        if(*sv1 != '\"')
                        {
                                //its an equation or an array.
                                if(*sv1 == '{')
                                {
                                        //its an array.
                                        //isolate and replace individual elems.
                                        while(!isalnum(*sv1) && *sv1 != '$' && *sv1 != '_')
                                        {
                                                if(*sv1 == '\"') goto skip_replacement;
                                                sv1++;
                                        }

                                        zerostring(&subequstr);
                                        for(sv2=sv1;*sv2;sv2++)
                                        {
                                                found = 0;
                                                if(*sv2 == '}') found=1;
                                                if(*sv2 == ',' || *sv2 == '}')
                                                {

                                                        //next term is found.
                                                        zerostring(&subequstr);
                                                        addrawstrn(&subequstr,sv1,sv2-sv1);
                                                        offset=sv1-varstr.str;

                                                        //it's in subequstr. evaluate.
                                                        intres = floatres = 0;
                                                        ret=eval_expression(subequstr.str,&intres,&intres,&floatres,7,0);
                                                        if(ret)
                                                        {
                                                                print_eval_error(ret);
                                                                killstring(&subequstr);
                                                                killstring(&varstr);
                                                                return 1;
                                                        }

                                                        //ok, have the result. replacestr it in!
                                                        memset(tempstr,0,32);
                                                        if(intres && !floatres) floatres=intres;
                                                        sprintf(tempstr,"%g",floatres);
                                                        replacestr(&varstr,offset,sv2-sv1,tempstr);
                                                        sv1 = varstr.str+offset+strlen(tempstr);

                                                        if(found) break;
                                                        while(!isalnum(*sv1) && *sv1 != '$' && *sv1 != '_') sv1++;
                                                        sv2=sv1;
                                                }
                                        }
                                        killstring(&subequstr);

                                }
                                else
                                {
                                        //standard equation, whoop it up.
                                        intres = floatres = 0;
                                        ret=eval_expression(varstr.str,&intres,&intres,&floatres,7,0);
                                        if(ret)
                                        {
                                                print_eval_error(ret);
                                                killstring(&varstr);
                                                return 1;
                                        }
                                        zerostring(&varstr);
                                        memset(tempstr,0,32);
                                        if(intres && !floatres) floatres=intres;
                                        sprintf(tempstr,"%g",floatres);
                                        addrawstr(&varstr,tempstr);
                                }
                        }

skip_replacement:

                        //at this point, varstr.str contains the final
                        //constant(s) to init to.
                        sv1 = varstr.str;

                        //check for illegal initializers, based on type.
                        if(!isdigit(*sv1) && *sv1 != '-' && (var_type == 3 || var_type == 4))
                        {
				SysErr("Initializer must be constant.");
                                killstring(&varstr);
				return 1;
                        }
                        if(!isdigit(*sv1) && *sv1 != '-' && *sv1 != '.' && var_type == 2)
                        {
				SysErr("Initializer must be constant.");
                                killstring(&varstr);
				return 1;
                        }
                        if(*sv1 == '-' && var_type == 4)
			{
				SysWarn("Sign out of range on initializer.");
			}
                        if(*sv1 != '\"' && var_type == 5)
			{
				SysErr("Initializer must be constant.");
                                killstring(&varstr);
				return 1;
			}
                        if((*sv1 != '{' && !isdigit(*sv1)) && var_type > 7 && var_type < 11)
                        {
                                SysErr("Initializer must be constant.");
                                killstring(&varstr);
                                return 1;
                        }
                        if((*sv1 != '{' && *sv1 != '\"') && var_type == 11)
                        {
                                SysErr("Initializer must be constant.");
                                killstring(&varstr);
                                return 1;
                        }

                        //ok, its legal.
			switch(var_type)
			{
			case 2: //real
                                pLastFunc->val.float_val = atof(sv1);
				break;
                        case 3: //signed
                                pLastFunc->val.long_val = atol(sv1);
				break;
                        case 4: //unsigned
                                pLastFunc->val.ulong_val = atol(sv1) > 0 ? atol(sv1) : -1 * atol(sv1);
				break;
			case 5: //string
                                sv1++;
                                for( p4=sv1; *p4; p4++)
                                {
                                        if(*p4 == '\"')
                                        {
                                                numslashes=0;
                                                for(n1 = p4-1;n1 > sv1-1;n1--)
                                                {
                                                        if(*n1 == '\\') numslashes++;
                                                        else break;
                                                }
                                                if(!(numslashes%2)) break;
                                        }
                                }
                                if( !(*p4) ) 
                                {
                                        SysErr("Unterminated string constant");
                                        killstring(&varstr);
                                        return 1;
                                }
                                addrawstrn(pLastFunc->val.str_val,sv1,p4-sv1);
				break;
                        case 8:
                                //real array
                                if(*sv1 == '{')
                                {
                                        //we have a list
                                        a1 = sv1;
                                        c = 0;
                                        while(*a1)
                                        {
                                                if(!isdigit(*a1) && *a1 != '.') { a1++; continue; }
                                                memset(curname,0,41);
                                                strcpy(curname,varname);
                                                strcat(curname,"[");
                                                strcat(curname,ltoa(c));
                                                strcat(curname,"]");
                                                create_intrinsic_function(curname,__user_eval_expression);
                                                pLastFunc->type = var_type-6; 
                                                pLastFunc->domain = domain;
                                                pLastFunc->parent = lpParentFunc;
                                                pLastFunc->val.float_val = atof(a1);
                                                lpParentFunc->children++;

                                                while(*a1)
                                                {
                                                        if(*a1 == ',' || *a1 == '}') break;
                                                        a1++;
                                                }

                                                if (*a1 == '}') break;
                                                c++;
                                        }
                                }
                                if(isdigit(*sv1))
                                {
                                        //just one. create it quick.
                                        strcat(varname,"[0]");
                                        create_intrinsic_function(varname,__user_eval_expression);
                                        pLastFunc->type = var_type-6; 
                                        pLastFunc->domain = domain;
                                        pLastFunc->parent = lpParentFunc;
                                        pLastFunc->val.float_val = atof(sv1);
                                        lpParentFunc->children++;
                                }
                                break;
                        case 9:
                                //int array
                                if(*sv1 == '{')
                                {
                                        //we have a list
                                        a1 = sv1;
                                        c = 0;
                                        while(*a1)
                                        {
                                                if(!isdigit(*a1)) { a1++; continue; }
                                                memset(curname,0,41);
                                                strcpy(curname,varname);
                                                strcat(curname,"[");
                                                strcat(curname,ltoa(c));
                                                strcat(curname,"]");
                                                create_intrinsic_function(curname,__user_eval_expression);
                                                pLastFunc->type = var_type-6; 
                                                pLastFunc->domain = domain;
                                                pLastFunc->parent = lpParentFunc;
                                                pLastFunc->val.long_val = atol(a1);
                                                lpParentFunc->children++;

                                                while(*a1)
                                                {
                                                        if(*a1 == ',' || *a1 == '}') break;
                                                        a1++;
                                                }

                                                if (*a1 == '}') break;
                                                c++;
                                        }
                                }
                                if(isdigit(*sv1))
                                {
                                        //just one. create it quick.
                                        strcat(varname,"[0]");
                                        create_intrinsic_function(varname,__user_eval_expression);
                                        pLastFunc->type = var_type-6; 
                                        pLastFunc->domain = domain;
                                        pLastFunc->parent = lpParentFunc;
                                        pLastFunc->val.long_val = atol(sv1);
                                        lpParentFunc->children++;
                                }
                                break;
                        case 10:
                                //uint array
                                if(*sv1 == '{')
                                {
                                        //we have a list
                                        a1 = sv1;
                                        c = 0;
                                        while(*a1)
                                        {
                                                if(!isdigit(*a1)) { a1++; continue; }
                                                memset(curname,0,41);
                                                strcpy(curname,varname);
                                                strcat(curname,"[");
                                                strcat(curname,ltoa(c));
                                                strcat(curname,"]");
                                                create_intrinsic_function(curname,__user_eval_expression);
                                                pLastFunc->type = var_type-6; 
                                                pLastFunc->domain = domain;
                                                pLastFunc->parent = lpParentFunc;
                                                pLastFunc->val.long_val = atol(a1) > 0 ? atol(a1) : 0 - atol(a1);

                                                lpParentFunc->children++;

                                                while(*a1)
                                                {
                                                        if(*a1 == ',' || *a1 == '}') break;
                                                        a1++;
                                                }

                                                if (*a1 == '}') break;
                                                c++;
                                        }
                                }
                                if(isdigit(*sv1))
                                {
                                        //just one. create it quick.
                                        strcat(varname,"[0]");
                                        create_intrinsic_function(varname,__user_eval_expression);
                                        pLastFunc->type = var_type-6; 
                                        pLastFunc->domain = domain;
                                        pLastFunc->parent = lpParentFunc;
                                        pLastFunc->val.long_val = atol(sv1) > 0 ? atol(sv1) : 0 - atol(sv1);
                                        lpParentFunc->children++;
                                }
                                break;
                        case 11:
                                //string array
                                if(*sv1 == '{')
                                {
                                        //we have a list
                                        a1 = p1;
                                        c = 0;
                                        while(*a1)
                                        {
                                                if(*a1 != '\"') { a1++; continue; }
                                                memset(curname,0,41);
                                                strcpy(curname,varname);
                                                strcat(curname,"[");
                                                strcat(curname,ltoa(c));
                                                strcat(curname,"]");
                                                create_intrinsic_function(curname,__user_eval_string);
                                                pLastFunc->type = var_type-6; 
                                                pLastFunc->domain = domain;
                                                pLastFunc->parent = lpParentFunc;

                                                pLastFunc->val.str_val = malloc(sizeof(SAFESTRING));
                                                if(!pLastFunc->val.str_val) 
                                                {
                                                        SysErr("Out of memory");
                                                        killstring(&varstr);
                                                        return 1;
                                                }
                                                zerostring(pLastFunc->val.str_val);

                                                a1++;
                                                for(a2=a1;*a2;a2++)
                                                {
                                                        if(*a2 == '\"')
                                                        {
                                                                numslashes=0;
                                                                for(n1 = a2-1;n1 > a1-1;n1--)
                                                                {
                                                                        if(*n1 == '\\') numslashes++;
                                                                        else break;
                                                                }
                                                                if(!(numslashes%2)) break;
                                                        }
                                                }
                                                if(!(*a2))
                                                {
                                                        SysErr("Unterminated string constant.");
                                                        killstring(&varstr);
                                                        return 1;
                                                }

                                                addrawstrn(pLastFunc->val.str_val,a1,a2-a1);


                                                lpParentFunc->children++;

                                                a1=a2;
                                                while(*a1)
                                                {
                                                        if(*a1 == ',' || *a1 == '}') break;
                                                        a1++;
                                                }

                                                if (*a1 == '}') break;
                                                c++;
                                        }
                                }
                                if(*sv1 == '\"')
                                {
                                        //just one element
                                        strcat(varname,"[0]");
                                        create_intrinsic_function(varname,__user_eval_expression);
                                        pLastFunc->type = var_type-6; 
                                        pLastFunc->domain = domain;
                                        pLastFunc->parent = lpParentFunc;

                                        pLastFunc->val.str_val = malloc(sizeof(SAFESTRING));
                                        if(!pLastFunc->val.str_val) 
                                        {
                                                SysErr("Out of memory");
                                                killstring(&varstr);
                                                return 1;
                                        }
                                        zerostring(pLastFunc->val.str_val);

                                        p1++;
                                        for( p4=sv1; *p4; p4++)
                                        {
                                                if(*p4 == '\"')
                                                {
                                                        numslashes=0;
                                                        for(n1 = p4-1;n1 > p4-1;n1--)
                                                        {
                                                                if(*n1 == '\\') numslashes++;
                                                                else break;
                                                        }
                                                        if(!(numslashes%2)) break;
                                                }
                                        }
                                        if( !(*p4) ) 
                                        {
                                                SysErr("Unterminated string constant");
                                                killstring(&varstr);
                                                return 1;
                                        }
                                        addrawstrn(pLastFunc->val.str_val,sv1,p4-sv1);

                                        lpParentFunc->children++;
                                }
                                break;
	                } //switch var type
		} //if p1 is legal 

                if(p5 == p7) break; //if we didn't find a comma, bail.
                p7 = p5;
        } //while there's more variable names to parse....

        killstring(&varstr);
        return 0;
}
